## Process Form Field Permission API Description
### Core Entry Class
Source code location：In the jar package starting with 'horizon-workflow-extend', under the 'com.horizon.workflow.form' path。
Factory class obtained from process form field permission interface: com.horizon.workflow.form.util.getFlowFieldAuthManager
Process Form Field Permission Query Interface Class：com.horizon.workflow.form.api.FlowFieldAuthApi
Process Form Field Permission Query Return Class：com.horizon.workflow.form.entity.FieldAuth

### Organization Data Query Invocation Instructions
When querying process modeling, mount the form and set permissions for the form fields. The invocation code structure is as follows：
```
//Get Operation Implementation Class
FlowFieldAuthApi fieldAuth = formFieldAuthFactory.getFlowFieldAuthManager();
```

### FieldAuth Return Result Set Description

| Property    | Type   | Necessity | Description                                                                   |
|-------------|--------|-----------|-------------------------------------------------------------------------------|
| id          | String | Yes       | Permission ID                                                                 |
| formId      | String | Yes       | Form ID                                                                       |
| authName    | String | Yes       | Permission Name                                                               |
| editField   | List   | No        | Editable fields, each consisting of a form ID and associated table fields     |
| checkField  | List   | No        | Fields must be filled, each consisting of form ID and associated table fields |
| hiddenField | List   | No        | Hidden fields, each consisting of a form ID and associated table fields       |
| readField   | List   | No        | Read only fields, each consisting of a form ID and associated table fields    |

## FlowFieldAuthApi Invocation Description
### getFieldAuth
**Description**
<table>
    <tr>
        <td>Method name</td>
        <td>GetFieldauth</td>
        <td>English name</td>
        <td></td>
    </tr>
    <tr>
        <td>Function description</td>
        <td colspan="3">Find users based on the type and ID of the organization</td>
    </tr>
    <tr>
        <td colspan="4" align="center">Interface information</td>
    </tr>
    <tr>
        <td>Interface type</td>
        <td>Api</td>
        <td>Interaction frequency</td>
        <td>Aperiodic</td>
    </tr>
    <tr>
        <td>Interface protocol</td>
        <td>Method Invocation</td>
        <td>Response time</td>
        <td></td>
    </tr>
</table>

**Parameter Description**

| Parameter Name | Type   | Required | Description   |
|----------------|--------|----------|---------------|
| authId         | String | √        | Permission Id |
** Invocation example**
```
FlowFieldAuthApi fieldAuthApi = formFieldAuthFactory.getFlowFieldAuthManager();
FieldAuth fieldAuth = fieldAuthApi. getFieldAuth(“HZ28e7f51e816d28011e816da7f1001f”);
```