# Process Action Description {docsify-ignore-all}
> Process operations include a series of process processing functions ,such as create, open, submit, and return

** Detailed list of process operations**

| Operation identification | Operation Type           | Description                                                                                                                                                                                                                                    |
|--------------------------|--------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| submit                   | Submit                   | Process submit operation, submit to next node.                                                                                                                                                                                                 |
| freesubmit               | Free Submit              | When submitting the process, the node operator can first add a virtual node, through which process can be used to submit to any node in this process.                                                                                          |
| innersubmit              | Internal Submit          | The process submission operate in Multi-Operator Order/Internal Loop node，Process willl not submit to the next node                                                                                                                            |
| subflow                  | Start sub process        | Starts the operation of sub processes.                                                                                                                                                                                                         |
| jiaqianBefore            | Pre-add Reviewer         | The node operator can add new reviewers before current reviewer as needed, the reviewer fills in the comments ,and can only submit them to the next reviewer of the current node. this operation is suitable for "Multi-Operator Order" nodes. |
| jiaqian                  | Add Reviewer             | The node operator can add reviewers as needed, the reviewer fills in the comments ,and can only submit them to the operator of the current node. this operation is suitable for "Multi-Operator ","Multi-Operator Order" nodes.                |
| reduceAuthor             | Remove Reviewer          | The node operator can reduce reviewers as needed before the reduced reviewer fills in the comments. this operation is suitable for "Multi-Operator","Multi-Operator Order" nodes.                                                              |
| urge                     | Urge                     | Send reminder notification messages to the current opertaors.                                                                                                                                                                                  |
| cancel                   | Terminate                | The creator of the instance can cancel.                                                                                                                                                                                                        |
| addSecondauthor          | Add secondary operator   | Secondary can only fill in comments and cannot submit the process to the next node.                                                                                                                                                            |
| secondSubmit             | Secondary submit         | The secondary submit their opinions to the primary within the node.                                                                                                                                                                            |
| reissue                  | Add  operator            | Add an operator at the current node, this operation can only be used on a Multi-Operator node.                                                                                                                                                 |
| reissuerouter            | Branch add operator      | This operation is suitable for nodes with multiple branches. If a node submits some branches for the first time, other branches can be additionally submitted.                                                                                 |
| replace                  | Replace Operator         | Replace the operator of the current node.                                                                                                                                                                                                      |
| huiqian                  | Initiate  Multi-Operator | Submit the process to multiple users within a node for Multi-Operator operation.                                                                                                                                                               |
| huiqianSubmit            | Parallel submit          | The process submission operation in Multi-Operator node                                                                                                                                                                                        |
| save                     | Save                     | Temporarily save the process data.                                                                                                                                                                                                             |
| addreader                | Send to read             | Add reader: Add user to be read at the current node.                                                                                                                                                                                           |
| readed                   | Read                     | Confirm that current operator have read the relevant information of this process.                                                                                                                                                              |
| reject                   | Return                   | Return to the previous submission node.                                                                                                                                                                                                        |
| jumpreject               | Return to Any Node       | Return the process instance to any node that the process has already passed through.                                                                                                                                                           |
| innerreject              | Internally Return        | Return operation within a Multi-Operator Order/Internal Loop node.                                                                                                                                                                             |
| rejectSubmit             | Return Submission        | Return the process instance to the previous submitted node                                                                                                                                                                                     |
| getback                  | Take back                | Allow the previous node submitter to take back before the current operator handles the process.                                                                                                                                                |
| goto                     | Jump                     | Jump to any processing node within the current process instance.                                                                                                                                                                               |
| stop                     | Terminate                | Terminate the current process, After termination, process cannot be restored. To-do has been changed to be read.                                                                                                                               |
| pause/resume             | Pause/Resume             | Pause/Resume process instance.                                                                                                                                                                                                                 |
| move                     | Transfer                 | Current operator transfer the operation of the current node to other user for processing.                                                                                                                                                      |
| claim                    | Claim                    | When a to-do is sent to a department or group, users under the this department or group will receive the claim message and can perform the claim operation if they need to handle this process.                                                |
| close                    | Close                    | After opening a process instance, the instance data is uploaded to the memory of the workflow engine to improve processing speed; After closing the process instance, the workflow engine releases it from memory.                             |

View existing instance information in the processed or to-do interfaces, or after creating a process instance, open the process, view the process status and action buttons, operate the process.

![Process operation](../../assets/img/rest/flowaction/flow.png)

**Interactions involved in process operations**

![Process Operation](../../assets/img/rest/flowaction/submit.png)

> Except for process creation and opening operations, other process operations mainly interact through the JSON data object actionData.

```
{
  "accessToken": "",
  "workId": "HZ28858f8137db820181383ef2a300a1",
  "trackId": "HZ28858f8137db820181383ef2a300a2",
  "actionData": {
    "operate": "submit",
    "operateClazz": "com.horizon.wf.action.ActionSubmit",
    "nextNodes": [
      {
        "selectId": "Line2~Node2",
        "isSelect": "true",
        "nodeKey": "Line2",
        "nodeId": "Node2"
      }
    ]
  }
}
```
> Users can control the global variable JSON object in JavaScript, and after calling submit and other operations, return JSON that can be assigned to actionData. After selecting a route or operator, assign a value to the actionData object, and then call the process operation interface

*As follows, obtain the data information that needs to be submitted through the browser console*

![Process Operation](../../assets/img/rest/flowaction/console.png)

> Users can also assign values to the actionData operation object and then call the process operation interface

**Process operation return result description:**
```
{
  "operate": "submit",
  "operateClazz": "com.horizon.wf.action.ActionSubmit",
  "operateText": "Submit",
  "operateFlag": "0",
  "operateMsg": "Submitted successfully",
  "reOpen": "false",
  "workId": "HZ2886865c0ec540015c0fb3103700da",
  "trackId": "HZ2886865c0ec540015c0fb3103800db",
  "nodeId": "Node1",
  "nodeName": "Task1",
  "subjection": "",
  "authorKey": "Author",
  "operateStatus": "success",
  “status": 0,
  "alert": "",
  "messageType": "",
  "nextNodes": [],
  "subFlows": []
}
```
| Parameter     | Type   | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
|---------------|--------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| operate       | String | Process operation identification                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| operateClazz  | String | Process operation class path                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| operateText   | String | Process  operation name                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| operateFlag   | String | Process  operation flag -1: Closed, 0: Normal submission, 1:Pre submission                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| operateMsg    | String | Process operation return information                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| reOpen        | String | Whether to reopen (active in memory), can be ignored                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| workId        | String | Instance ID                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| trackId       | String | Track ID                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| nodeId        | String | Current node ID                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| nodeName      | String | Current node name                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| subjection    | String | Organization ID where the operator is located                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          |
| authorKey     | String | Operator ID                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| operateStatus | String | Process operation result, Success: Operation succeeded; Error: operation failed; Selectsubflow: Sub process needs to be selected;showSubflow: Sub process has already been started, multiple starts are not allowed.                                                                                                                                                                                                                                                                                                                                                                                   |
| status        | int    | Process operation return status;0: Operation successful;2: Select node;3: Missing operator;4: Please select operator;All other values are operation errors;1: The process cannot find the next node, please check the route;9: Other parameter errors;14: Sub processes have already been started, multiple starts are not allowed;15: Sub processes need to be selected;17: Do not comply with the leave rule, Cannot leave the current node;120: Locked by someone else;130: Instance is currently flowing in another engine;140: Process paused;200: License verification failed;210: No permission ||MessageType | String | Message sending type  |
| nextNodes     | List   | List of next node                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| subFlows      | List   | List of sub process                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |