# Claim{docsify-ignore-all}
> Process Claim 

Interface Request Invoking Description<br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post Data Description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b0181192b2357040e",
  "trackId": "HZ28858f8113f08b0181192b2357040f",
  "actionData": {
    "operate": "claim",
    "operateClazz": "com.horizon.wf.action.ActionClaim"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData Parameter :

| Parameter    | Required | Description                                                   |
|--------------|----------|---------------------------------------------------------------|
| operate      | Yes      | Claim operation identifier, fixed value 'Claim'               |
| operateClazz | Yes      | Claim Operation Class Path: com.horizon.wf.action.ActionClaim |
**Example of returned results：**
```
{
  "alert": "true",
  "operate": "claim",
  "operateClazz": "com.horizon.wf.action.ActionClaim",
  "operateFlag": "1",
  "operateMsg": "Successfully claimed",
  "operateStatus": "success",
  "reOpen": "true",
  "status": 0,
  "workId": "HZ28858f8113f08b0181192b2357040e"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                      |
|---------------|--------|------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored |
| operate       | String | Claim operation identification                                   |
| operateClazz  | String | Claim operation class path                                       |
| operateFlag   | String | Operation flag -1: Closed, 0, 1: Normal submission               |
| operateMsg    | String | Process operation return information                             |
| operateStatus | String | Process operation results                                        |
| reOpen        | String | Whether to reopen, can be ignored                                |
| status        | int    | Process operation status code                                    |
| workId        | String | Instance ID                                                      |
