# Close{docsify-ignore-all}

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post Data Description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f80f4ecfe0180ff30bf52017e",
  "trackId": "HZ28858f80f4ecfe0180ff30bf52017f",
  "actionData": {
    "operate": "close",
    "reOpen":false
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData Description:

| Parameter | Required | Description                                     |
|-----------|----------|-------------------------------------------------|
| operate   | Yes      | Close operation identifier, fixed value 'Close' |
| reOpen    | Yes      | Whether to reopen, fixed value 'False'          |

**Example of returned results:**
```
{
    "operate": "close",
    "operateFlag": "1",
    "operateStatus": "success",
    "reOpen": "false",
    "status": 0,
    "trackId": "HZ28858f80f4ecfe0180ff30bf52017f",
    "workId": "HZ28858f80f4ecfe0180ff30bf52017e"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                        |
|---------------|--------|----------------------------------------------------|
| operate       | String | Operation identification, fixed value              |
| operateFlag   | String | Operation flag -1: Closed, 0, 1: Normal submission |
| operateStatus | String | Process operation results                          |
| reOpen        | String | Whether to reopen, can be ignored                  |
| status        | int    | Process operation status code                      |
| trackId       | String | Flow track ID                                      |
| workId        | String | Instance ID                                        |

