# Take Back
> Retrieve from the current processing node

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858d720cb01101720d4f42de01b4",
  "trackId": "HZ28858d720cb01101720d4f42de01b5",
  "actionData": {
    "operate": "getback",
    "operateClazz": "com.horizon.wf.action.ActionGetBack"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData parameter:

| Parameter    | Required | Description                                                           |
|--------------|----------|-----------------------------------------------------------------------|
| operate      | Yes      | Operation ID, fixed value 'Take back'                                 |
| operateClazz | Yes      | Retrieve the operation class path:com.horizon.wf.action.ActionGetBack |
**Example of returned results:**
```
{
    "alert": "true",
    "operate": "getback",
    "operateClazz": "com.horizon.wf.action.ActionGetBack",
    "operateFlag": "1",
    "operateMsg": "Taken back successfully",
    "operateStatus": "success",
    "reOpen": "false",
    "status": 0,
    "workId": "HZ28858f8113f08b018113f08be70001"
}
```

**Result parameter description:**

| Parameter     | Type   | Description                                                      |
|---------------|--------|------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored |
| operate       | String | Take back operation identification                               |
| operateClazz  | String | take back operation class path                                   |
| operateFlag   | String | Operation flag -1: closed, 0, 1: normal submission               |
| operateMsg    | String | Process operation return information                             |
| operateStatus | String | Process operation results                                        |
| reOpen        | String | Whether to reopen, can be ignored                                |
| status        | int    | Process operation status code                                    |
| workId        | String | Intance ID                                                       |
