# Multi-Operator Handle
>Start Multi-Operator handling, Parallel submitting

![Process operation](../../assets/img/rest/flowaction/huiqian.png)
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112c6620f036b",
  "trackId": "HZ28858f8103505e018112c6620f036c",
  "actionData": {
    "operate": "huiqian",
    "operateFlag": 0,
    "operateText": "Start Multi-Operator handling",
    "operateClazz": "com.horizon.wf.action.ActionHuiQian",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow Track ID                                  |
| nodeId      | Yes      | Node ID                                        |
| actionData  | Yes      | Process operation JSON data                    |
actionData  Parameter:

| Parameter    | Required | Description                                                                              |
|--------------|----------|------------------------------------------------------------------------------------------|
| operate      | Yes      | Operation identification, fixed value 'huiqian'                                          |
| operateFlag  | Yes      | Operation ID, fixed value '0 '                                                           |
| operateText  | Yes      | Operation name, fixed value: "Start Multi-Operator handling"                             |
| operateClazz | Yes      | Operation specific implementation class, fixed value:com.horizon.wf.action.ActionHuiQian |
| nextNodes    | Yes      | List of nodes to be selected                                                             |
nextNodes  parameter description:：

| Parameter | Required | Description                                                                                                |
|-----------|----------|------------------------------------------------------------------------------------------------------------|
| authors   | Yes      | In the next node, the key in the operator object is 'Author', and the value is the Author object parameter |
| nodeKey   | Yes      | Node primary key                                                                                           |
| nodeId    | Yes      | Node ID to be selected                                                                                     |
| selectId  | Yes      | Selected Node ID                                                                                           |
Author object parameter description in authors:

| Parameter        | Required | Description                             |
|------------------|----------|-----------------------------------------|
| selectAuthor     | Yes      | The selected operatorr ID of the node   |
| selectAuthorName | Yes      | The selected operatorr name of the node |
**Example of returned results:**
```
{
    "nextNodeId": "Node1",
    "nextNodes": [
        {
            "authors": {
                "Author": {
                    "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
                    "selectAuthorName": "User01(Test Department0)"
                }
            },
            "isSelect": "true",
            "nodeKey": "Node1",
            "nodeName": "Node1",
            "selectId": "Node1"
        }
    ],
    "operate": "huiqian",
    "operateClazz": "com.horizon.wf.action.ActionHuiQian",
    "operateFlag": "0",
    "operateMsg": "Multi-operator handled succesfully",
    "operateStatus": "success",
    "status": 0,
    "workId": "HZ28858f8103505e018112db6ce203b8"
}
```
**Result  parameter description::**

| Parameter    | Type   | Description                                                              |
|--------------|--------|--------------------------------------------------------------------------|
| operate      | String | Operation identification of multi-operator handle, fixed value ‘huiqian’ |
| operateClazz | String | Specific Implementation Class for multi-operator handle Operations       |
| operateFlag  | String | Operation flag -1: closed, 0, 1: normal submission                       |
| operateMsg   | String | Other submitted data                                                     |
| nextNodeId   | String | Current node ID                                                          |
| workId       | String | Instance ID                                                              |
| status       | int    | Process operation status code                                            |
| nextNodes    | List   | List of nodes to be selected                                             |
*nextNodes  parameter description:：*

| Parameter  | Type   | Description                                                                                        |
|------------|--------|----------------------------------------------------------------------------------------------------|
| nodeKey    | String | Node primary key                                                                                   |
| selectId   | String | Node ID to be selected                                                                             |
| selectName | String | Node name to be selected                                                                           |
| isSelect   | String | Has it been selected                                                                               |
| authors    | Map    | The key in the operator map of the next node is 'Author', and value is the Author object parameter |
*Author  parameter description:：*

| Parameter        | Type   | Description                            |
|------------------|--------|----------------------------------------|
| selectAuthor     | String | The selected operator ID of the node   |
| selectAuthorName | String | The selected operator name of the node |

## Parallel submit
Interface Request Invoking Description<br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112db6ce203b8",
  "trackId": "HZ28858f8103505e018112db6ce203b9",
  "actionData": {
    "operate": "huiqianSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitHuiqian"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow Track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData  Parameter:

| Parameter    | Required | Description                                                                                |
|--------------|----------|--------------------------------------------------------------------------------------------|
| operate      | Yes      | Read operation ID, fixed value huiqianSubmit                                               |
| operateClazz | Yes      | Parallel submit operation class path，fixed value:com.horizon.wf.action.ActionSubmitHuiqian |
**Example of returned results:**
```
{
  "alert": "true",
  "operate": "huiqianSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitHuiqian",
  "operateFlag": "1",
  "operateMsg": "Parallel submitted  successfully",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018112db6ce203b8"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                      |
|---------------|--------|------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored |
| operate       | String | Parallel submit operation identification                         |
| operateClazz  | String | Parallel submit operation class path                             |
| operateFlag   | String | Operation flag -1: closed, 0, 1: normal submission               |
| operateMsg    | String | Process operation return information                             |
| operateStatus | String | Process operation results                                        |
| reOpen        | String | Whether to reopen, can be ignored                                |
| status        | int    | Process operation status code                                    |
| workId        | String | Instance ID                                                      |
