# Internal Submit{docsify-ignore-all}

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811456bf9e01ae",
  "trackId": "HZ28858f8113f08b01811456bf9e01af",
  "actionData": {
    "authorKey": "Author",
    "nextNodeId": "Node2",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "authorId": "Author",
            "authorName": "Primary",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
            "selectAuthorName": "Admin（HuizhengSoftware）"
          }
        },
        "isSelect": "true",
        "nodeId": "Node2",
        "nodeKey": "Node2",
        "selectId": "Node2"
      }
    ],
    "nodeId": "Node2",
    "operate": "innerSubmit",
    "operateClazz": "com.horizon.wf.action.ActionSubmitForProgressively",
    "operateFlag": 0
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Process instance ID                            |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData  parameter :

| Parameter    | Required | Description                                                                             |
|--------------|----------|-----------------------------------------------------------------------------------------|
| authorKey    | Yes      | Identity of the operator                                                                |
| nextNodeId   | Yes      | Next Node ID                                                                            |
| nextNodes    | Yes      | List of next nodes to be selected                                                       |
| nodeId       | Yes      | Current node ID                                                                         |
| operate      | Yes      | Internal submission operation identification 'Internal Submit'                          |
| operateClazz | Yes      | Internal submission operation  path: com.horizon.wf.action.ActionSubmitForProgressively |
| operateFlag  | Yes      | Operation identification ，fixed value: 0                                                |
nextNodes Parameter Description：

| Parameter | Required | Description                                                |
|-----------|----------|------------------------------------------------------------|
| authors   | Yes      | The key in the operator 'map' of the next node is 'Author' |
| isSelect  | Yes      | Has it been selected?                                      |
| nodeId    | Yes      | Node ID                                                    |
| nodeKey   | Yes      | Node primary key                                           |
| selectId  | Yes      | Node ID to be selected                                     |
Author Object Parameter Description in 'Authors'：

| Parameter        | Required | Description                                                                                    |
|------------------|----------|------------------------------------------------------------------------------------------------|
| authorId         | No       | Operator type ID, limited value 'Author'                                                       |
| authorName       | No       | Name of Operator, limit values: Primary, Secondary, Reader                                     |
| freeArea         | No       | Scope of free choice                                                                           |
| isDefUser        | No       | Select from the organization library of process node attributes                                |
| isFree           | No       | Whether to choose freely                                                                       |
| isSelect         | No       | Is it allowed to select the operator?                                                          |
| isUser           | No       | Is it allowed to only select personnel                                                         |
| selectType       | No       | Personnel selection type, limited value, Radio: single selection; Checkbox: multiple selection |
| selectAuthor     | Yes      | The selected operator ID of the node                                                           |
| selectAuthorName | Yes      | Name of the selected operator for the node                                                     |
**Example of returned results:**
```
{
  "nextNodeId": "Node2",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectAuthor": "U_admin/D_HZ28821856ef63420156ef63429c0000",
          "selectAuthorName": "Admin(HuizhengSoftware)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "nodeGroup": "",
      "nodeId": "Node2",
      "nodeKey": "Node2",
      "nodeName": "Task2",
      "selectId": "Node2",
      "selectName": "Internal Submt (Task2)"
    }
  ],
  "operate": "innerSubmit",
  "operateClazz": "com.horizon.wf.action.ActionSubmitForProgressively",
  "operateFlag": "0",
  "operateMsg": "Submitted successfully",
  "operateStatus": "success",
  "status": 0,
  "workId": "HZ28858f8113f08b01811456bf9e01ae"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | Internal submission operation identification                                       |
| operateClazz | String | Internal submission operation class path                                           |
| operateFlag  | String | Operation flag -1: Display closed, 0, 1: Normal submission                         |
| operateMsg   | String | Return operation information                                                       |
| status       | int    | Process operation status code                                                      |
| workId       | String | Process instance ID                                                                |
*nextNodes parameter description:*

| Parameter  | Type   | Description                                                                                                               |
|------------|--------|---------------------------------------------------------------------------------------------------------------------------|
| authors    | Map    | The key in the operator map of the next node is Author, and value is the Author object parameter                          |
| isDone     | String | Has it already passed by                                                                                                  |
| isSelect   | String | Has it been selected                                                                                                      |
| isShowTabs | String | Whether to display the operator tab page, it is used to display the operator that has already processed the flow.         |
| nodeGroup  | String | Node grouping, with no value for a single node. When the current node has branch nodes, the value is the previous node ID |
| nodeId     | String | Current node ID                                                                                                           |
| nodeKey    | String | Current node primary key                                                                                                  |
| nodeName   | String | Current node name                                                                                                         |
| nodeStatus | String | Node status, limited value: 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found  |
| selectId   | String | Node ID to be selected                                                                                                    |
| selectName | String | Node name to be selected                                                                                                  |
*Author parameter description in Authors:*

| Parameter        | Type   | Description                                                                                  |
|------------------|--------|----------------------------------------------------------------------------------------------|
| authorId         | String | Opertor ID，fixed value: Author                                                               |
| authorName       | String | Name of Operator, limit values: Primary, Secondary, Reader                                   |
| freeArea         | String | Scope of operators for free selection                                                        |
| isDefUser        | String | Select from the organization library of process node attributes                              |
| isFree           | String | Whether to freely choose the operator                                                        |
| isSelect         | String | Is it allowed to select the operator?                                                        |
| isUser           | String | Allow selection of personnel?                                                                |
| selectAuthor     | String | The selected operator ID of the node                                                         |
| selectAuthorName | String | Name of the selected operator for the node                                                   |
| selectType       | String | Personnel selection type, limited value,Radio: single selection;Checkbox: multiple selection |
