# Transfer{docsify-ignore-all}
> Transfer the operation of the current node to other user for processing

Interface Request invoking Description <br>
HTTP request method:POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e018112d629e4039d",
  "trackId": "HZ28858f8103505e018112d629e4039e",
  "actionData": {
    "operate": "move",
    "operateClazz": "com.horizon.wf.action.ActionMove",
    "operateFlag": "0",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node1",
        "nodeId": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData parameter:

| Parameter    | Required | Description                                                                           |
|--------------|----------|---------------------------------------------------------------------------------------|
| operate      | Yes      | Transfer operation, fixed value:move                                                  |
| operateFlag  | Yes      | Transfer operation identifier, fixed value:0                                          |
| operateClazz | Yes      | Operation specific implementation class, fixed value:com.horizon.wf.action.ActionMove |
| nextNodes    | Yes      | List of next nodes in the process                                                     |
nextNodes parameter description：

| Parameter | Required | Description                                                                                              |
|-----------|----------|----------------------------------------------------------------------------------------------------------|
| authors   | Yes      | In the next node, the key in the operator object is Author, and the value is the Author object parameter |
| isSelect  | Yes      | Has the next node been selected, fixed value:True                                                        |
| nodeKey   | Yes      | Node primary key                                                                                         |
| selectId  | Yes      | Selected next node ID                                                                                    |
| nodeId    | Yes      | Current node ID                                                                                          |
Author Object Parameter Description in Authors：

| Parameter        | Required | Description                 |
|------------------|----------|-----------------------------|
| selectAuthor     | Yes      | Selected node operator ID   |
| selectAuthorName | Yes      | Selected node operator name |
**Example of returned results:**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User01(Test Department0)"
        }
      },
      "isSelect": "true",
      "nodeKey": "Node1",
      "nodeId": "Node1",
      "selectId": "Node1"
    }
  ],
  "operate": "move",
  "operateClazz": "com.horizon.wf.action.ActionMove",
  "operateFlag": "0",
  "operateMsg": "Successfully transferred",
  "operateStatus": "success",
  "operateText": "Transfer",
  "status": 0,
  "workId": "HZ28858f8103505e018112d629e4039d"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                                        |
|---------------|--------|------------------------------------------------------------------------------------|
| nextNodeId    | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes     | List   | List of next nodes to be selected                                                  |
| operate       | String | Transfer operation identification                                                  |
| operateClazz  | String | Transfer operation class path                                                      |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission,1:Pre submission           |
| operateMsg    | String | Return operation information                                                       |
| operateStatus | String | Return operation results                                                           |
| operateText   | String | Operation display name                                                             |
| status        | int    | Process operation status code                                                      |
| workId        | String | Instance ID                                                                        |
*nextNodes parameter description:*

| Parameter | Type   | Description                                                                                                           |
|-----------|--------|-----------------------------------------------------------------------------------------------------------------------|
| authors   | Map    | The key in the operator map of the next node is Primary Operator, and value is the Primary Operator object parameter. |
| isSelect  | String | Has it been selected?                                                                                                 |
| nodeKey   | String | Node primary key                                                                                                      |
| nodeId    | String | Node ID                                                                                                               |
| selectId  | String | Next node id to be selected                                                                                           |
*Author parameter description in Authors:*

| Parameter        | Type   | Description                 |
|------------------|--------|-----------------------------|
| selectAuthor     | String | Selected node operator ID   |
| selectAuthorName | String | Selected node operator name |