# Open Process{docsify-ignore-all}
>When opening a process, processes that are idle in memory will become active. The process instance ID and process track ID required for opening can be found in the returned results of creating the process.

Interface Request Invoking Description<br>
HTTP Request Method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/open${suffix} <br>
**Post Data Description：**
```
{
  "accessToken": "",
  "workId": "",
  "trackId": "",
  "subjection": ""
}
```
Request parameter description:

| Parameter   | Required | Description                                                                                                                                                                                                                                                                                                                         |
|-------------|----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                                                                                                                                                                                                                                                      |
| workId      | Yes      | Instance ID                                                                                                                                                                                                                                                                                                                         |
| trackId     | Yes      | Flow track ID                                                                                                                                                                                                                                                                                                                       |
| subjection  | No       | The set ID to which the current user belongs (such as department ID, group ID, position ID, etc.), When opening the process, this field is passed in (when the operator belongs to multiple identities, the operator opens the process as the primary, this field must be passed in). The format is: D_ Xxxxid G_ Xxxxid P_ Xxxxid. |
**Example of returned results:**
```
{
  "authorKey": "Author",
  "flowButtons": [
    {
      "buttonClass": "com.horizon.wf.action.ActionStop",
      "buttonFun": "",
      "buttonId": "stop",
      "buttonName": "Terminate",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionSubmitForFree",
      "buttonFun": "",
      "buttonId": "freesubmit",
      "buttonName": "Free Submit",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionReject",
      "buttonFun": "",
      "buttonId": "reject",
      "buttonName": "Return",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionSubmit",
      "buttonFun": "",
      "buttonId": "submit",
      "buttonName": "Submit",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionSave",
      "buttonFun": "",
      "buttonId": "save",
      "buttonName": "Save",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionHuiQian",
      "buttonFun": "",
      "buttonId": "huiqian",
      "buttonName": "Initiate Multi-Operator",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionGoto",
      "buttonFun": "",
      "buttonId": "goto",
      "buttonName": "Jump",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionAddReader",
      "buttonFun": "",
      "buttonId": "addreader",
      "buttonName": "Add reader",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionPause",
      "buttonFun": "",
      "buttonId": "pause",
      "buttonName": "Pause",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionAddSecondAuthor",
      "buttonFun": "",
      "buttonId": "addSecondauthor",
      "buttonName": "Add Secondary Operator",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionRejectByJump",
      "buttonFun": "",
      "buttonId": "jumpreject",
      "buttonName": "Return to Any Node",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionStartMultiSubFlow",
      "buttonFun": "",
      "buttonId": "subflow",
      "buttonName": "Start sub process",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionReMsg",
      "buttonFun": "",
      "buttonId": "urge",
      "buttonName": "Urge",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionCancel",
      "buttonFun": "",
      "buttonId": "cancel",
      "buttonName": "Withdraw",
      "icon": ""
    },
    {
      "buttonClass": "com.horizon.wf.action.ActionReplaceAuthor",
      "buttonFun": "",
      "buttonId": "replace",
      "buttonName": "Replace Operator",
      "icon": ""
    }
  ],
  "flowForms": [
    {
      "formAuthId": "alleditable",
      "formBody": "",
      "formButton": "",
      "formDataId": "FlowTrack",
      "formDatas": "",
      "formFieldAuth": "",
      "formFields": "",
      "formId": "FlowTrack",
      "formName": "FlowTrack",
      "formType": "",
      "isDef": "true",
      "isNewData": "false"
    },
    {
      "formAuthId": "HZ28858f8137db82018137db82aa0000",
      "formBody": "",
      "formButton": "",
      "formDataId": "HZ28858f8137db820181380971db0046",
      "formDatas": "",
      "formFieldAuth": {
        "authName": "test_auth",
        "checkField": [
          "HZ28858f80b64b190180b64e3f8f0028_P2"
        ],
        "editField": [
          "HZ28858f80b64b190180b64e3f8f0028_P2",
          "HZ28858f80b64b190180b64e3f8f0028_NAME"
        ],
        "formId": "HZ28858f80b64b190180b64e3f8f0028",
        "hiddenField": [],
        "readField": [
          "HZ28858f80b64b190180b64e3f8f0028_P1"
        ]
      },
      "formFields": "",
      "formId": "HZ28858f80b64b190180b64e3f8f0028",
      "formName": "Test Form",
      "formType": "CUSTOM",
      "isDef": "",
      "isNewData": "true"
    }
  ],
  "flowId": "test",
  "flowMsg": "OK",
  "flowName": "New flow",
  "flowNode": {
    "memo": "",
    "nodeId": "Node1",
    "nodeName": "Task1",
    "nodeVars": {
      "testA": "10",
      "testB": "hello"
    },
    "trackId": "HZ28858f8137db82018137ebd76b0033"
  },
  "flowStatus": "110",
  "flowStatusName": "Normal",
  "flowUser": {
    "author": "Author;Creator;Manager",
    "authorName": "Primary;Creator;Administrator",
    "deptId": "HZ28821856ef63420156ef63429c0000",
    "deptName": "Huizheng Software",
    "transactor":"admin",
    "transactorName": "Administrator",
    "userId": "admin",
    "userName": "Administrator"
  },
  "flowVars": {
    "varA": "10"
  },
  "hasForm": "true",
  "openType": "true",
  "selectNodes": "",
  "subjectionId": "",
  "workId": "HZ28858f8137db82018137ebd76b0032"
}
```
**Result parameter description:**

| Parameter      | Type   | Description                                                                                                                                                         |
|----------------|--------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authorKey      | String | Current identity of the operator                                                                                                                                    |
| flowButtons    | List   | Process operation button information, details can be found in the 'flowButtons' parameter description                                                               |
| flowForms      | List   | Process form information, details can be found in the 'flowForms' parameter description                                                                             |
| flowId         | String | Flow ID                                                                                                                                                             |
| flowMsg        | String | Process return information                                                                                                                                          |
| flowName       | String | Flow name                                                                                                                                                           |
| flowNode       | Object | Current node information, details can be found in the 'flowNode' parameter description                                                                              |
| flowUser       | Object | The current user information for process execution can be found in the 'flowUser' parameter description for details                                                 |
| flowStatus     | String | Process status, 100: draft; 110: normal; 120: Multi-operator; 130: Return; 140: Suspend; 150: Withdraw; 160: Sub process; 170: End; 180: Terminate; 190: Take back. |
| flowStatusName | String | Process Status Display Name                                                                                                                                         |
| flowVars       | Map    | Process variable, where 'key' is the variable name and 'value' is the variable value                                                                                |
| hasForm        | String | Does it contain business forms?                                                                                                                                     |
| openType       | String | Process Open Status                                                                                                                                                 |
| selectNodes    | List   | When the current operator is in multiple activity nodes, it is necessary to select the node to open the instance                                                    |
| workId         | String | Instance ID                                                                                                                                                         |
| subjectionId   | String | The set ID to which the current user belongs (such as department ID, group ID, position ID, etc.)                                                                   |
*flowButtons  parameter description:*

| Parameter   | Type   | Description                           |
|-------------|--------|---------------------------------------|
| buttonClass | String | Operation button implementation class |
| buttonFun   | String | Button event                          |
| buttonId    | String | Button ID                             |
| buttonName  | String | Button name                           |
| icon        | String | Button style                          |
*flowForms  parameter description:*

| Parameter     | Type   | Description                                        |
|---------------|--------|----------------------------------------------------|
| formAuthId    | String | Field permission ID                                |
| formBody      | String | Form content                                       |
| formButton    | List   | Form button                                        |
| formDataId    | String | Form Data ID                                       |
| formDatas     | Object | Form data (extended fields, temporarily not used)  |
| formFieldAuth | Object | Form field permission information                  |
| formFields    | Object | Form field (extended fields, temporarily not used) |
| formId        | String | Form ID                                            |
| formName      | String | Form name                                          |
| formType      | String | Form type: external form, custom form              |
| isDef         | String | Is it the default form?                            |
| isNewData     | String | Is it a new form data?                             |
*flowNode  parameter description:*

| Parameter | Type   | Description                                                                                                                   |
|-----------|--------|-------------------------------------------------------------------------------------------------------------------------------|
| memo      | String | Node description information                                                                                                  |
| nodeId    | String | Node ID                                                                                                                       |
| nodeName  | String | Node Name                                                                                                                     |
| nodeVars  | Map    | The current node parameter, where key is the variable name and value is the variable value, is only valid at the current node |
| trackId   | String | Flow track  ID                                                                                                                |
*flowUser  parameter description:*

| Parameter      | Type   | Description                                         |
|----------------|--------|-----------------------------------------------------|
| author         | String | User Identity ID: Primary/Secondary/Creator/Reader  |
| authorName     | String | User Identity Name:Primary/Secondary/Creator/Reader |
| deptId         | String | Department ID                                       |
| deptName       | String | Department name                                     |
| transactor     | String | Processing user ID                                  |
| transactorName | String | Processing user name                                |
| userId         | String | User ID                                             |
| userName       | String | User name                                           |
*formFieldAuth  parameter description:*

| Parameter   | Type   | Description                                                                           |
|-------------|--------|---------------------------------------------------------------------------------------|
| authName    | String | Permission Name                                                                       |
| formId      | String | Form ID                                                                               |
| editField   | List   | Editable fields, each with a form ID and associated table field concatenation         |
| checkField  | List   | Required fields, each item is a concatenation of form ID and associated table fields  |
| hiddenField | List   | Hidden fields, each item is a concatenation of form ID and associated table fields    |
| readField   | List   | Read only fields, each item is a concatenation of form ID and associated table fields |
