 # Add operator
> Add an operator at the current node、including branch add operator 

## Add operator
Interface Request invoking Description <br>
HTTP Request Method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b0181196387730476",
  "trackId": "HZ28858f8113f08b0181196387730477",
  "actionData": {
    "operate": "reissue",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionReissue",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20007",
            "selectAuthorName": "User06"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node2",
        "nodeId": "Node2",
        "selectId": "Node2"
      }
    ]
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData   Parameter:

| Parameter    | Required | Description                                                                             |
|--------------|----------|-----------------------------------------------------------------------------------------|
| operate      | Yes      | 'Add operator' operation identification, fixed value:'reissue'                          |
| operateFlag  | Yes      | Operation identification, fixed value::0                                                |
| operateClazz | Yes      | 'Add operator' operation class path, fixed value:'com.horizon.wf.action.ActionReissue ' |
| nextNodes    | Yes      | List of next nodes to be set                                                            |
nextNodes  parameter description：

| Parameter | Required | Description                                                                                                              |
|-----------|----------|--------------------------------------------------------------------------------------------------------------------------|
| authors   | Yes      | The key in the operator object of next node is Primary Operator, and the value is the Primary Operator object parameter. |
| nodeKey   | Yes      | Current node primary key                                                                                                 |
| nodeId    | Yes      | Current node ID                                                                                                          |
| selectId  | Yes      | Next node id to be selected                                                                                              |
Author object parameter description in authors:

| Parameter        | Required | Description                 |
|------------------|----------|-----------------------------|
| selectAuthor     | Yes      | Selected node operator id   |
| selectAuthorName | Yes      | Selected node operator name | |
**Example of returned results:**
```
{
  "nextNodeId": "Node2",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node2",
      "nodeKey": "Node2",
      "nodeName": "Task2",
      "nodeStatus": "0",
      "selectId": "Node2",
      "selectName": "Add operator(Task2)"
    }
  ],
  "operate": "reissue",
  "operateClazz": "com.horizon.wf.action.ActionReissue",
  "operateFlag": "0",
  "operateMsg": "Added operator successfully",
  "status": 0,
  "workId": "HZ28858f8113f08b0181196387730476"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | 'Add operator' operation identification.                                           |
| operateClazz | String | 'Add operator' operation class path                                                |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg   | String | Return operation information                                                       |
| status       | int    | Process operation status code                                                      |
| workId       | String | Instance ID                                                                        |
*nextNodes  parameter description：*

| Parameter  | Type   | Description                                                                                                                                                                                          |
|------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors    | Map    | The key in the operator map of the next node is Author, and value is the Author object parameter.                                                                                                    |
| isDone     | String | Has the process once passed the next node before?                                                                                                                                                    |
| isSelect   | String | Has the next node been selected?                                                                                                                                                                     |
| isShowTabs | String | Whether to display operator tab page of the process node                                                                                                                                             |
| memo       | String | memo                                                                                                                                                                                                 |
| nodeGroup  | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| nodeId     | String | Current node ID                                                                                                                                                                                      |
| nodeKey    | String | Current node primary key                                                                                                                                                                             |
| nodeName   | String | Current node name                                                                                                                                                                                    |
| nodeStatus | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| selectId   | String | Next node id to be selected                                                                                                                                                                          |
| selectName | String | Next node name to be selected                                                                                                                                                                        |
*Author  parameter description in 'authors'：*

| Parameter     | Type   | Description                                                                                  |
|---------------|--------|----------------------------------------------------------------------------------------------|
| authorFlowVar | String | Process variables                                                                            |
| authorId      | String | Operator ID, Fixed value:  'Author'                                                          |
| authorName    | String | Operator name:'Primary'                                                                      |
| freeArea      | String | Scope of free choice                                                                         |
| isDefUser     | String | Select from the organization library of process node attributes                              |
| isFree        | String | Whether to select freely                                                                     |
| isSelect      | String | Is it allowed to select the operator?                                                        |
| isUser        | String | Is it allowed to select the user?                                                            |
| selectType    | String | Operator selection type, limited value. Radio: Single selection;Checkbox: Multiple selection |

##  Branch add operator
> When submitting multiple branches, supplement other branch node operators
![Flow operation](../../assets/img/rest/flowaction/track.png)

### Branch add operator-Get branch nodes
Interface Request invoking Description <br>
HTTP Request Method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811d39e32f070e",
  "trackId": "HZ28858f8113f08b01811d39e32f070f",
  "actionData": {
    "operate": "reissuerouter",
    "operateClazz": "com.horizon.wf.action.ActionReissueRouter"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Process operation JSON data                    |
actionData   Parameter:

| Parameter    | Required | Description                                                                                  |
|--------------|----------|----------------------------------------------------------------------------------------------|
| operate      | Yes      | 'Add operator' operation identification, fixed value:'reissuerouter'                         |
| operateClazz | Yes      | 'Add operator' operation class path, fixed value:'com.horizon.wf.action.ActionReissueRouter' |
**Example of returned results:**
```
{
  "nextNodeId": "",
  "nextNodes": [
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node3",
      "nodeKey": "Line3",
      "nodeName": "Task3",
      "nodeStatus": "0",
      "selectId": "Line3~Node3",
      "selectName": "Track3(Task3)",
      "timeLimit": "0",
      "timeLimitType": "1"
    },
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node4",
      "nodeKey": "Line4",
      "nodeName": "Task4",
      "nodeStatus": "0",
      "selectId": "Line4~Node4",
      "selectName": "Track4(Task4)",
      "timeLimit": "0",
      "timeLimitType": "1"
    }
  ],
  "operate": "reissuerouter",
  "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
  "operateFlag": "1",
  "operateMsg": "Please select the branch node for adding operator",
  "status": 2,
  "workId": "HZ28858f8113f08b01811d39e32f070e"
}
```
**Result parameter description:**

| Parameter    | Type   | Description                                                                        |
|--------------|--------|------------------------------------------------------------------------------------|
| nextNodeId   | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes    | List   | List of next nodes to be selected                                                  |
| operate      | String | 'Add operator' operation identification.                                           |
| operateClazz | String | 'Add operator' operation class path .                                              |
| operateFlag  | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg   | String | Return operation information                                                       |
| workId       | String | Instance ID                                                                        |
| status       | int    | Process operation status code                                                      |
*nextNodes  parameter description：*

| Parameter     | Type   | Description                                                                                                                                                                                          |
|---------------|--------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors       | Map    | The key in the operator map of the next node is Author, and value is the Author object parameter.                                                                                                    |
| isDone        | String | Has the process once passed the next node before?                                                                                                                                                    |
| isSelect      | String | Has the next node been selected?                                                                                                                                                                     |
| memo          | String | memo                                                                                                                                                                                                 |
| nodeGroup     | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information |
| nodeId        | String | Current node ID                                                                                                                                                                                      |
| nodeKey       | String | Current node primary key                                                                                                                                                                             |
| nodeName      | String | Current node name                                                                                                                                                                                    |
| nodeStatus    | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                             |
| selectId      | String | Next node id to be selected                                                                                                                                                                          |
| selectName    | String | Next node name to be selected                                                                                                                                                                        |
| timeLimit     | String | Node processing deadline                                                                                                                                                                             |
| timeLimitType | String | Processing time limit type, limit value. 0: Calendar day; 1: Working day                                                                                                                             |

### Branch add operator-Set branch node operator 
> When submitting multiple branches, supplement other branch node operators

Interface Request invoking Description <br>
HTTP Request Method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action${suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811de1b6710751",
  "trackId": "HZ28858f8113f08b01811de1b6710752",
  "actionData": {
    "authorKey": "Author",
    "nextNodeId": "",
    "nextNodes": [
      {
        "authors": {
          "SecondAuthor": {
            "authorFlowVar": "",
            "authorId": "SecondAuthor",
            "authorName": "Secondary",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User02(Test Department0)"
          },
          "Reader": {
            "authorFlowVar": "",
            "authorId": "Reader",
            "authorName": "Reader",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20004/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User03(Test Department0)"
          },
          "Author": {
            "authorFlowVar": "",
            "authorId": "Author",
            "authorName": "Primary",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isDone": "false",
        "isSelect": "true",
        "memo": "",
        "nodeGroup": "",
        "nodeId": "Node3",
        "nodeKey": "Line3",
        "nodeName": "Task3",
        "nodeStatus": "4",
        "selectId": "Line3~Node3",
        "selectName": "Track3(Task3)",
        "timeLimit": "1",
        "timeLimitType": "0"
      },
      {
        "authors": {
          "SecondAuthor": {
            "authorFlowVar": "",
            "authorId": "SecondAuthor",
            "authorName": "Secondary",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User02(Test Department0)"
          },
          "Reader": {
            "authorFlowVar": "",
            "authorId": "Reader",
            "authorName": "Reader",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20004/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User03(Test Department0)"
          },
          "Author": {
            "authorFlowVar": "",
            "authorId": "Author",
            "authorName": "Primary",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "User01(Test Department0)"
          }
        },
        "isDone": "false",
        "isSelect": "true",
        "memo": "",
        "nodeGroup": "",
        "nodeId": "Node4",
        "nodeKey": "Line4",
        "nodeName": "Task4",
        "nodeStatus": "4",
        "selectId": "Line4~Node4",
        "selectName": "Track4(Task4)",
        "timeLimit": "1",
        "timeLimitType": "0"
      }
    ],
    "nodeId": "Node2",
    "nodeName": "Task2",
    "operate": "reissuerouter",
    "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
    "operateFlag": 0
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Track ID                                       |
| actionData  | Yes      | Process operation JSON data                    |
actionData   Parameter:

| Parameter    | Required | Description                                                                            |
|--------------|----------|----------------------------------------------------------------------------------------|
| authorKey    | Yes      | Operator type ID                                                                       |
| nextNodeId   | Yes      | Next node ID                                                                           |
| nextNodes    | Yes      | List of branch nodes that need to be set                                               |
| nodeId       | Yes      | Current node ID                                                                        |
| nodeName     | Yes      | Current node name                                                                      |
| operate      | Yes      | 'Branch add operator' operation identification, fixed value:'reissuerouter'            |
| operateClazz | Yes      | 'Branch add operator' operation class path:'com.horizon.wf.action.ActionReissueRouter' |
| operateFlag  | Yes      | Branch operation identification, fixed value:'0'                                       |
nextNodes  parameter description：

| Parameter     | Required | Description                                                                                                                                                                                           |
|---------------|----------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors       | Yes      | The key in the next node's operator object is Primary operator,Secondary operator, and Reader, the value is the Primary/Secondary/Reader object parameter.                                            |
| isDone        | No       | Has the process once passed the next node before?                                                                                                                                                     |
| isSelect      | Yes      | Has the next node been selected?                                                                                                                                                                      |
| memo          | No       | Memo                                                                                                                                                                                                  |
| nodeGroup     | No       | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information. |
| nodeId        | Yes      | Current node ID                                                                                                                                                                                       |
| nodeKey       | Yes      | Current node primary key                                                                                                                                                                              |
| nodeName      | No       | Current node name                                                                                                                                                                                     |
| nodeStatus    | No       | Node status                                                                                                                                                                                           |
| selectId      | Yes      | Next node id to be selected                                                                                                                                                                           |
| selectName    | No       | Next node name to be selected                                                                                                                                                                         |
| isShowTabs    | No       | Whether to display operator tab page of the process node                                                                                                                                              |
| timeLimit     | No       | Node processing deadline                                                                                                                                                                              |
| timeLimitType | No       | Processing time limit type, limit value. 0: Calendar day; 1: Working day                                                                                                                              |
Primary/Secondary/Reader object parameter description in authors:

| Parameter        | Required | Description                                                                                                        |
|------------------|----------|--------------------------------------------------------------------------------------------------------------------|
| authorFlowVar    | No       | Process variables                                                                                                  |
| authorId         | No       | Operator type ID, limit value. Author: Primary; SecondAuthor: Secondary; Reader:Reader                             |
| authorName       | No       | Operator type name: Primary/Secondary/Reader                                                                       |
| freeArea         | No       | Scope of free choice                                                                                               |
| isDefUser        | No       | Select from the organization library of process node attributes                                                    |
| isFree           | No       | Whether to select freely                                                                                           |
| isSelect         | No       | Is it allowed to select the operator                                                                               |
| isUser           | No       | Is it allowed to select the user?                                                                                  |
| selectType       | No       | Operator selection type, limited value. Radio: Single selection;Checkbox: Multiple selection                       |
| selectAuthor     | Yes      | The selected operator ID of the node. it can be left blank when the operator does not have a Secondary or Reader   |
| selectAuthorName | Yes      | The selected operator name of the node. it can be left blank when the operator does not have a Secondary or Reader |
| authorName       | No       | Operator name, limit value: Primary, Secondary, Reader                                                             |

**Example of returned results:**
```
{
  "nextNodeId": "Line3~Node3&Line4~Node4",
  "nextNodes": [
    {
      "authors": {
        "SecondAuthor": {
          "authorFlowVar": "",
          "authorId": "SecondAuthor",
          "authorName": "Secondary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User02(Test Department0)",
          "selectType": "checkbox"
        },
        "Reader": {
          "authorFlowVar": "",
          "authorId": "Reader",
          "authorName": "Reader",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20004",
          "selectAuthorName": "User03",
          "selectType": "checkbox"
        },
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User01(Test Department0)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node3",
      "nodeKey": "Line3",
      "nodeName": "Task3",
      "nodeStatus": "0",
      "selectId": "Line3~Node3",
      "selectName": "Track3(Task3)",
      "timeLimit": "1",
      "timeLimitType": "0"
    },
    {
      "authors": {
        "SecondAuthor": {
          "authorFlowVar": "",
          "authorId": "SecondAuthor",
          "authorName": "Secondary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User02(Test Department0)",
          "selectType": "checkbox"
        },
        "Reader": {
          "authorFlowVar": "",
          "authorId": "Reader",
          "authorName": "Reader",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20004",
          "selectAuthorName": "User 03",
          "selectType": "checkbox"
        },
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "Primary",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "User01(Test Department0)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node4",
      "nodeKey": "Line4",
      "nodeName": "Task4",
      "nodeStatus": "0",
      "selectId": "Line4~Node4",
      "selectName": "track4(task4)",
      "timeLimit": "1",
      "timeLimitType": "0"
    }
  ],
  "operate": "reissuerouter",
  "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
  "operateFlag": "0",
  "operateMsg": "Successfully branch added operator",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "trackId": "HZ28858f8113f08b01811de5c2290787;HZ28858f8113f08b01811de5c2290788",
  "workId": "HZ28858f8113f08b01811de1b6710751"
}
```
**Result  parameter description:**

| Parameter     | Type   | Description                                                                        |
|---------------|--------|------------------------------------------------------------------------------------|
| nextNodeId    | String | Next node ID (used when the next node ID is known and there is only one next node) |
| nextNodes     | List   | List of next nodes to be selected                                                  |
| operate       | String | 'Add operator' operation identification.                                           |
| operateClazz  | String | 'Add operator' operation class path                                                |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission         |
| operateMsg    | String | Process operation return information                                               |
| operateStatus | String | Return operation results                                                           |
| reOpen        | String | Whether to reopen, can be ignored                                                  |
| status        | int    | Process operation status code                                                      |
| workId        | String | Instance ID                                                                        |
| trackId       | String | Track ID                                                                           |
*nextNodes  parameter description：*

| Parameter     | Type   | Description                                                                                                                                                                                           |
|---------------|--------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| authors       | Map    | The key in the next node's operator map is Primary,Secondary, and Reader, the value is the Primary/Secondary/Reader object parameter.                                                                 |
| isDone        | String | Has the process once passed the next node before?                                                                                                                                                     |
| isSelect      | String | Has the next node been selected?                                                                                                                                                                      |
| memo          | String | memo                                                                                                                                                                                                  |
| nodeGroup     | String | If there are no multiple branches in the current instance, this value is empty. If there are multiple branches, this value returns the node ID of the previous node to bind the grouping information. |
| nodeId        | String | Current node ID                                                                                                                                                                                       |
| nodeKey       | String | Current node primary key                                                                                                                                                                              |
| nodeName      | String | Current node name                                                                                                                                                                                     |
| nodeStatus    | String | Node status, limited value, 0. Success; 1. Select operator; 2. Select node; 3. Operator not found;4. Next node not found                                                                              |
| selectId      | String | Next node id to be selected                                                                                                                                                                           |
| selectName    | String | Next node name to be selected                                                                                                                                                                         |
| timeLimit     | String | Node processing deadline                                                                                                                                                                              |
| timeLimitType | String | Processing time limit type, limit value. 0: Calendar day; 1: Working day                                                                                                                              |
Primary/Secondary/Reader object parameter description in authors:

| Parameter        | Type   | Description                                                                                                        |
|------------------|--------|--------------------------------------------------------------------------------------------------------------------|
| authorFlowVar    | String | Process variables                                                                                                  |
| authorId         | String | Processor type ID, limit value, Author: Primary; SecondAuthor: Secondary; Reader: Reader                           |
| authorName       | String | Operator type name: Primary/Secondary/Reader                                                                       |
| freeArea         | String | Scope of free choice                                                                                               |
| isDefUser        | String | Select from the organization library of process node attributes                                                    |
| isFree           | String | Whether to select freely                                                                                           |
| isSelect         | String | Is it allowed to select the operator                                                                               |
| isUser           | String | Is it allowed to select the user?                                                                                  |
| selectAuthor     | String | The selected operator ID of the node. it can be left blank when the operator does not have a Secondary or Reader   |
| selectAuthorName | String | The selected operator name of the node. it can be left blank when the operator does not have a Secondary or Reader |
| selectType       | String | Operator selection type, limited value. Radio: Single selection;Checkbox: Multiple selection                       |
