# Terminate{docsify-ignore-all}
>Terminate the current process.，Process termination is irreversible and cannot be restored once terminated

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d1445000e2",
  "workId": "HZ28858f8103505e018104d1445000e1",
  "actionData": {
    "operate": "stop",
    "operateClazz": "com.horizon.wf.action.ActionStop"
  }
}
```
Request parameter description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData parameter:

| Parameter    | Required | Description                                                         |
|--------------|----------|---------------------------------------------------------------------|
| operate      | Yes      | 'Terminate' operation identification, Fixed value:'stop'            |
| operateClazz | Yes      | 'Terminate' operation class path:'com.horizon.wf.action.ActionStop' |
**Example of returned results:**
```
{
  "alert": "true",
  "operate": "stop",
  "operateClazz": "com.horizon.wf.action.ActionStop",
  "operateFlag": "1",
  "operateMsg": "Terminated process successfully",
  "operateStatus": "success",
  "operateText": "Terminate",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018104d1445000e1"
}
```

**Result parameter description:**

| Parameter     | Type   | Description                                                                |
|---------------|--------|----------------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored           |
| operate       | String | 'Terminate' operation identification                                       |
| operateClazz  | String | 'Terminate' operation class path                                           |
| operateFlag   | String | Operation flag -1: Display closed, 0: Normal submission, 1: Pre submission |
| operateMsg    | String | Process operation return information                                       |
| operateStatus | String | Process operation results                                                  |
| reOpen        | String | Whether to reopen, can be ignored                                          |
| status        | int    | Process operation status code                                              |
| workId        | String | Instance ID                                                                |
