# Urge,Revoke
> Send reminder notification messages to the current opertaors;  The creator of the instance can terminate.

## Urge
Interface Request Invoking Description <br>
HTTP request method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d8a1dc0110",
  "workId": "HZ28858f8103505e018104d8a1dc010f",
  "actionData": {
    "operate": "urge",
    "operateClazz": "com.horizon.wf.action.ActionReMsg"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData   parameter 

| Parameter    | Required | Description                                                         |
|--------------|----------|---------------------------------------------------------------------|
| operate      | Yes      | Operation identification of 'Urge',fix value:'urge'                 |
| operateClazz | Yes      | 'Reminder' Operation class path:'com.horizon.wf.action.ActionReMsg' |
**Example of returned results:**
```
{
  "alert": "true",
  "operate": "urge",
  "operateClazz": "com.horizon.wf.action.ActionReMsg",
  "operateFlag": "1",
  "operateMsg": "Sent reminder successfully",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018104d8a1dc010f"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                       |
|---------------|--------|-------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored  |
| operate       | String | Operation identification,fixed value                              |
| operateClazz  | String | 'Reminder' operation class path                                   |
| operateFlag   | String | Operation flag -1: Closed, 0: Normal submission, 1:Pre submission |
| operateMsg    | String | Process operation return information                              |
| operateStatus | String | Process operation results                                         |
| reOpen        | String | Whether to reopen, can be ignored                                 |
| status        | int    | Process operation status code                                     |
| workId        | String | Instance ID                                                       |

## Revoke
> After the instance is terminated, if the method is called again, the instance will be restored

Interface Request Invoking Description <br>
HTTP request method: POST <br>
Request address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**Post data description:**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d8a1dc0110",
  "workId": "HZ28858f8103505e018104d8a1dc010f",
  "actionData": {
    "operate": "cancel",
    "operateClazz": "com.horizon.wf.action.ActionCancel"
  }
}
```
Request Parameter Description:

| Parameter   | Required | Description                                    |
|-------------|----------|------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID |
| workId      | Yes      | Instance ID                                    |
| trackId     | Yes      | Flow track ID                                  |
| actionData  | Yes      | Other submitted data                           |
actionData   parameter 

| Parameter    | Required | Description                                                         |
|--------------|----------|---------------------------------------------------------------------|
| operate      | Yes      | 'Revoke' operation identification,fixed value 'Terminate'           |
| operateClazz | Yes      | 'Revoke' operation class path :'com.horizon.wf.action.ActionCancel' |
**Example of returned results：**
```
{
  "alert": "true",
  "operate": "cancel",
  "operateClazz": "com.horizon.wf.action.ActionCancel",
  "operateFlag": "1",
  "operateMsg": "Revocation of process is successfiul",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018104d8a1dc010f"
}
```
**Result parameter description:**

| Parameter     | Type   | Description                                                       |
|---------------|--------|-------------------------------------------------------------------|
| alert         | String | Whether to pop up a successful operation message, can be ignored  |
| operate       | String | 'Revoke' operation identification,fixed value                     |
| operateClazz  | String | 'Revoke' operation class path                                     |
| operateFlag   | String | Operation flag -1: Closed, 0: Normal submission, 1:Pre submission |
| operateMsg    | String | Process operation return information                              |
| operateStatus | String | Process operation results                                         |
| reOpen        | String | Whether to reopen, can be ignored                                 |
| status        | int    | Process operation status code                                     |
| workId        | String | Instance ID                                                       |
