# Processed work

## Processed list
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/haddone/page${suffix} <br>
**Post Data Description：**
```
{
  "accessToken": "",
  "requestType": "",
  "page": "1",
  "limit": "10",
  "sort": "sendTime",
  "search": ""
}
```
Request Parameter Description:

| Parameter   | Required | Description                                                                                                                                                                                      |
|-------------|----------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                                                                                                                   |
| requestType | Yes      | Business name: 'HadDone' represents querying the list of processed tasks, 'HadRead' represents querying the list of reviewed tasks, 'AllowRead' represents querying the list of to be read tasks |
| page        | No       | Page number, if left blank, all data will be displayed                                                                                                                                           |
| limit       | No       | The number of data items displayed per page, if left blank, default to displaying 10 items per page                                                                                              |
| sort        | No       | Not required. If a minus sign is added before the field, such as sort=- created, it will be arranged in reverse order of 'created'                                                               |
| search      | No       | Query title field, default to empty, default to displaying all data                                                                                                                              |
**Example of returned results：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "Newflowtest",
      "limitTime": "",
      "nodeId": "Node1",
      "nodeName": "Task1",
      "sendSubjectionName": "",
      "sendTime": "2022-05-12 13:27:52",
      "sendUserName": "Admin",
      "subjectionId": "D_HZ28821856ef63420156ef63429c0000",
      "title": "Newflowtest,Processed.",
      "trackId": "HZ28858f80b6b2380180b6bcdf8f0048",
      "workId": "HZ28858f80b6b2380180b6bcdf8f0047"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**Result parameter description:**

| Parameter    | Type   | Description                          |
|--------------|--------|--------------------------------------|
| flowId       | String | Flow ID                              |
| flowName     | String | Flow Name                            |
| sendTime     | String | Send Time，Format：yyyy-MM-dd HH:mm:ss |
| limitTime    | String | Processing time limit                |
| nodeId       | String | To-do node ID                        |
| nodeName     | String | To-do node name                      |
| sendUserName | String | Sender name                          |
| subjectionId | String | Organization ID of the sender        |
| title        | String | Flow title                           |
| trackId      | String | Track ID                             |
| workId       | String | Instance ID                          |

## Launched List
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/hadstarted/page${suffix} <br>
**Post Data Description：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
Request Parameter Description:

| Parameter   | Required | Description                                                                                                                                           |
|-------------|----------|-------------------------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                                                                        |
| page        | No       | Page number, if left blank, all data will be displayed                                                                                                |
| limit       | No       | The number of data items displayed per page, if left blank, default to displaying 10 items per page                                                   |
| sort        | No       | Sort, default to positive order. If a minus sign is added before a field, such as sort=- flowName, it will be arranged in reverse order of 'flowName' |
| search      | No       | Query title field, default to empty, query all data                                                                                                   |
**Example of returned results：**
```
{
  "code": 0,
  "data": [
    {
      "flowName": "Newflowtest",
      "id": "HZ28858f80b6b2380180b6bcdf8f0047",
      "startTime": "2022-05-12 13:27:52",
      "title": "Newflowtest"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**Result parameter description:**

| Parameter | Type   | Description                           |
|-----------|--------|---------------------------------------|
| flowName  | String | Flow Name                             |
| id        | String | Process instance ID                   |
| startTime | String | Send time, Format：yyyy-MM-dd HH:mm:ss |
| title     | String | Flow title                            |

## Withdrawn list
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/undo/page${suffix} <br>
**Post Data Description:**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": ""
}
```
Request Parameter Description:

| Parameter   | Required | Description                                                                                                                                         |
|-------------|----------|-----------------------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                                                                      |
| page        | No       | Page number, if left blank, all data will be displayed                                                                                              |
| limit       | No       | The number of data items displayed per page, if left blank, default to displaying 10 items per page                                                 |
| sort        | No       | Sort, default to positive order. If a minus sign is added before a field, such as sort=- flowName, it will be arranged in reverse order of flowName |
| search      | No       | Query title field, default is empty, query all data                                                                                                 |
**Example of returned results：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "Newflowtest",
      "startTime": "2022-05-12 14:21:25",
      "title": "Newflowtest",
      "trackId": "HZ28858f80b6ec710180b6ede4ce001d",
      "workId": "HZ28858f80b6ec710180b6ede4ce001c"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**Result parameter description:**

| Parameter | Type   | Description                                    |
|-----------|--------|------------------------------------------------|
| flowId    | String | Flow id                                        |
| flowName  | String | Flow name                                      |
| startTime | String | Instance start time,Format：yyyy-MM-dd HH:mm:ss |
| title     | String | Flow title                                     |
| tracId    | String | Process track ID                               |
| workId    | String | Process instance ID                            |