# Obtain operation records{docsify-ignore-all}

Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/history${suffix} <br>
**Post Data Description：**
```
{
  "accessToken": "",
  "workId": "",
  "skipFields": "limittime;dotimemin"
}
```
Request Parameter Description:

| Parameter   | Required | Description                                                                                                  |
|-------------|----------|--------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                               |
| workId      | Yes      | Flow instance ID                                                                                             |
| skipFields  | No       | Field names that need to be filtered out (do not need to be returned), if empty, all fields will be returned |
**Example of returned results：**
```
{
  "code": 0,
  "data": [
    {
      "action": "autofirst",
      "actionname": "Start Flow",
      "actiontime": "2022-05-19 10:11:49",
      "comments": "",
      "dotime": "0 Days 0 Hours 0 Minutes",
      "dotimemin": "0",
      "flowid": "test",
      "flowname": "Newflowtest",
      "id": "HZ28858f80da101c0180da15e4370060",
      "isover": "0",
      "limittime": "",
      "memo": "Submitted to node [Task 1] Processed by: Administrator (Huizheng Software)",
      "nextnodeids": "Node1;",
      "nodeid": "Start",
      "nodename": "Start",
      "sxcomments": "",
      "title": "Newflowtest",
      "trackid": "HZ28858f80da101c0180da15e433005e",
      "userid": "admin",
      "username": "Admin",
      "workid": "HZ28858f80da101c0180da15e433005d"
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**Result parameter description:**

| Parameter   | TYpe   | Description                                                                                                 |
|-------------|--------|-------------------------------------------------------------------------------------------------------------|
| action      | String | Operation ID                                                                                                |
| actionname  | String | Operation Name                                                                                              |
| actiontime  | String | Operation Time                                                                                              |
| comments    | String | Comments                                                                                                    |
| dotime      | String | Duration from receipt to operation                                                                          |
| dotimemin   | String | Duration (minutes)                                                                                          |
| flowid      | String | FLow ID                                                                                                     |
| flowname    | String | Flow Name                                                                                                   |
| id          | String | Record Data ID                                                                                              |
| isover      | String | Has the operation exceeded the deadline? 1: Yes ,0: No                                                      |
| limittime   | String | Node processing deadline                                                                                    |
| memo        | String | The operation information(time, operator, operation, next operator)  recorded after executing the operation |
| nextnodeids | String | Next node ID, there is no value when the process operation has not the next node                            |
| nodeid      | String | Node ID where the process operation occurs                                                                  |
| nodename    | String | Node name                                                                                                   |
| sxcomments  | String | Comments                                                                                                    |
| title       | String | Title                                                                                                       |
| trackid     | String | Flow track ID                                                                                               |
| userid      | String | User ID                                                                                                     |
| username    | String | User name                                                                                                   |
| workid      | String | Instance ID                                                                                                 |
