# To-do

## To-do list
Interface Request Invoking Description <br>
HTTP Request Method: POST <br>
Request Address: http://127.0.0.1:8080/demo/horizon/workflow/rest/todo/page${suffix}<br>
**Post Data Description：**
```
{
  "accessToken": "",
  "requestType": "",
  "page": "1",
  "limit": "10",
  "sort": "sendTime",
  "search": ""
}
```
Request Parameter Description:

| Parameter   | Required | Description                                                                                                                          |
|-------------|----------|--------------------------------------------------------------------------------------------------------------------------------------|
| accessToken | Yes      | Invoking interface credentials, unique user ID                                                                                       |
| requestType | Yes      | Business name: 'TodoList'  represents  to-do lists, 'BackLog' represents 'Claiming Todo', and 'MatterRead' represents 'to be read '  |
| page        | No       | Page number, if left blank, all data will be displayed                                                                               |
| limit       | No       | The number of data items displayed per page, if left blank, default to displaying 10 items per page                                  |
| sort        | No       | Not required. If a minus sign is added before the field, such as sort=- sendTime, it will be arranged in reverse order of 'sendTime' |
| search      | No       | Query title field, default to empty, query all data                                                                                  |
**Example of returned results：**
```
{
  "code": 0,
  "data": [
    {
      "flowId": "test",
      "flowName": "Newflowtest",
      "limitTime": "0(Days)",
      "nodeId": "Node2",
      "nodeName": "Task2",
      "sendSubjectionName": "Department",
      "sendTime": "2022-05-12 13:28:02",
      "sendUserName": "Admin",
      "subjectionId": "D_HZ28821856ef63420156ef63429c0000",
      "title": "Newflowtest,Please handle.",
      "trackId": "HZ28858f80b6b2380180b6bcdf8f0048",
      "workId": "HZ28858f80b6b2380180b6bcdf8f0047"
    }
  ],
  "message": "",
  "recordsTotal": "1",
  "success": true
}
```
**Result parameter description:**

| Parameter          | Type   | Description                           |
|--------------------|--------|---------------------------------------|
| flowId             | String | Flow id                               |
| flowName           | String | Flow Name                             |
| limitTime          | String | Processing time limit                 |
| nodeId             | String | To-do node ID                         |
| nodeName           | String | To-do node Name                       |
| sendSubjectionName | String | Name of organization                  |
| sendTime           | String | Send time,Format: yyyy-MM-dd HH:mm:ss |
| sendUserName       | String | Sender Name                           |
| title              | String | Flow title                            |
| trackId            | String | Track ID                              |
| workId             | String | Instance ID                           |



