### 工作移交(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>handoverWork</td>
        <td>中文名称</td>
        <td>工作移交</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于工作移交(此方法只做移交标记,并不实际修改权限,实际权限更改在接收人接收后执行)</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">public boolean handoverWork(List&lt;Map&lt;String,String&gt;&gt; list, boolean preservePermissions,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称                | 类型     | 是否必填 | 描述                 |
|---------------------|--------|------|--------------------|
| List &#60;Map&#62;  | List   |      |                    |
| Key=workid          | String | √    | 要进行移交的工作列表(实例id)   |
| Key=trackid         | String | √    | 要进行移交的工作列表(路径id)   |
| Key=olduserid       | String | √    | 移交人ID 带前缀,如U_admin |
| Key=newuserid       | String | √    | 接收人ID 带前缀,如U_admin |
| Key= newusername    | String | √    | 接收人姓名              |
| Key= oldusername    | String | √    | 移交人姓名              |
| preservePermissions | String | √    | 是否保留权限 1保留 0不保留    |
| tenantid            | String | √    | 租户id               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.handoverWork(List<Map>,false,tenantid);
```
### 工作移交
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>handoverWork</td>
        <td>中文名称</td>
        <td>工作移交</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于工作移交(此方法只做移交标记,并不实际修改权限,实际权限更改在接收人接收后执行)</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">public boolean handoverWork(List&lt;Map&lt;String,String&gt;&gt; list, boolean preservePermissions, String tenantid, String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称                | 类型     | 是否必填 | 描述                 |
|---------------------|--------|------|--------------------|
| List &#60;Map&#62;  | List   |      |                    |
| Key=workid          | String | √    | 要进行移交的工作列表(实例id)   |
| Key=trackid         | String | √    | 要进行移交的工作列表(路径id)   |
| Key=olduserid       | String | √    | 移交人ID 带前缀,如U_admin |
| Key=newuserid       | String | √    | 接收人ID 带前缀,如U_admin |
| Key= newusername    | String | √    | 接收人姓名              |
| Key= oldusername    | String | √    | 移交人姓名              |
| preservePermissions | String | √    | 是否保留权限 1保留 0不保留    |
| tenantid            | String | √    | 租户id               |
| identifier          | String | √    | 数据源标识              |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.handoverWork(List<Map>,false,tenantid,identifier);
```
### 接收工作移交(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>receiveHandoverWork</td>
        <td>中文名称</td>
        <td>接收工作移交</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于工作移交之后调用此方法接收</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">Map&lt;DBHandover,String&gt; receiveHandoverWork(List&lt;DBHandover&gt; list, String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型                        | 是否必填 | 描述         |
|----------|---------------------------|------|------------|
| List     | List &#60;DBHandover&#62; | √    | 要进行接收的工作列表 |
| tenantid | String                    | √    | 租户id       |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
Map<DBHandover,String> result = iwm.receiveHandoverWork(list, tenantid);
```
### 接收工作移交
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>receiveHandoverWork</td>
        <td>中文名称</td>
        <td>接收工作移交</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于工作移交之后调用此方法接收</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">Map&lt;DBHandover,String&gt; receiveHandoverWork(List&lt;DBHandover&gt; list, String tenantid, String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型                        | 是否必填 | 描述         |
|------------|---------------------------|------|------------|
| List       | List &#60;DBHandover&#62; | √    | 要进行接收的工作列表 |
| tenantid   | String                    | √    | 租户id       |
| identifier | String                    | √    | 数据源标识      |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
Map<DBHandover,String> result = iwm.receiveHandoverWork(list, tenantid, identifier);
```
### 激活流程(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
         <td>activeTrack</td>
        <td>中文名称</td>
        <td>激活流程</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于激活流程</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean activeTrack(String workid,String trackid,String interfaceClass,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称           | 类型     | 是否必填 | 描述            |
|----------------|--------|------|---------------|
| workid         | String | √    | 实例id          |
| trackid        | String | √    | 路径id          |
| interfaceClass | String | √    | 激活时要执行的类包含全路径 |
| tenantid       | String | √    | 租户id          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.activeTrack(workid,trackid,interfaceclass,tenantid);
```
### 激活流程
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>activeTrack</td>
        <td>中文名称</td>
        <td>激活流程</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于激活流程</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean activeTrack(String workid,String trackid,String interfaceClass,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称           | 类型     | 是否必填 | 描述            |
|----------------|--------|------|---------------|
| workid         | String | √    | 实例id          |
| trackid        | String | √    | 路径id          |
| interfaceClass | String | √    | 激活时要执行的类包含全路径 |
| tenantid       | String | √    | 租户id          |
| identifier     | String | √    | 数据源标识         |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManage();
boolean result = iwm.activeTrack(workid,trackid,interfaceclass,tenantid,identifier);
```
### 恢复实例数据(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>replaceWork</td>
        <td>中文名称</td>
        <td>恢复实例数据</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于流程实例恢复到之前的版本</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean replaceWork(String workid,int version,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述   |
|----------|--------|------|------|
| workid   | String | √    | 实例id |
| version  | int    | √    | 版本   |
| tenantid | String | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.replaceWork(workid,version,tenantid);
```
### 恢复实例数据
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>replaceWork</td>
        <td>中文名称</td>
        <td>恢复实例数据</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于流程实例恢复到之前的版本</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">>boolean replaceWork(String workid,int version,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| version    | int    | √    | 版本    |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.replaceWork(workid,trackid,tenantid,identifier);
```
### 获取实例最大版本号(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getWorkMaxVersion</td>
        <td>中文名称</td>
        <td>获取实例最大版本号</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于获取指定流程实例id的最大版本号</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getWorkMaxVersion(String workid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述   |
|----------|--------|------|------|
| workid   | String | √    | 实例id |
| tenantid | String | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.getWorkMaxVersion(workid,tenantid);
```
### 获取实例最大版本号
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getWorkMaxVersion</td>
        <td>中文名称</td>
        <td>获取实例最大版本号</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于获取指定流程实例id的最大版本号</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getWorkMaxVersion(String workid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.getWorkMaxVersion(workid,trackid,identifier);
```
### 暂停/恢复实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>pauseWork</td>
        <td>中文名称</td>
        <td>暂停、恢复实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于暂停指定workid和trackid的实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean pauseWork(String workid,String trackid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述   |
|----------|--------|------|------|
| workid   | String | √    | 实例id |
| trackid  | String | √    | 路径id |
| tenantid | String | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.pauseWork(workid,trackid,tenantid);
```
### 暂停/恢复实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>pauseWork</td>
        <td>中文名称</td>
        <td>暂停、恢复实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于暂停指定workid和trackid的实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean pauseWork(String workid,String trackid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| trackid    | String | √    | 路径id  |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.pauseWork(workid,trackid,tenantid,identifier);
```
### 批量暂停/恢复实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>pauseWork</td>
        <td>中文名称</td>
        <td>暂停、恢复实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量暂停指定workid和trackid的实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">String pauseWork(String[] workids,String[] trackids,String tenantid)<br>返回执行失败的workid,多个用逗号</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型       | 是否必填 | 描述   |
|----------|----------|------|------|
| workids  | String[] | √    | 实例id |
| trackids | String[] | √    | 路径id |
| tenantid | String   | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
String[] trackids = {"yyy"};
String result = iwm.pauseWork (workids,trackids,tenantid,tenantid);
```
### 批量暂停/恢复实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>pauseWork</td>
        <td>中文名称</td>
        <td>暂停、恢复实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
         <td colspan="3">此服务用于批量暂停指定workid和trackid的实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">String pauseWork(String[] workids,String[] trackids,String tenantid,String identifier
)<br>返回执行失败的workid,多个用逗号</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型       | 是否必填 | 描述    |
|------------|----------|------|-------|
| workids    | String[] | √    | 实例id  |
| trackids   | String[] | √    | 路径id  |
| tenantid   | String   | √    | 租户id  |
| identifier | String   | √    | 数据源标识 |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
String[] trackids = {"yyy"};
String result = iwm. pauseWork (workids,trackids,tenantid,tenantid,identifier);
```
### 结束实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>stopWork</td>
        <td>中文名称</td>
        <td>结束实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean stopWork(String workid,String trackid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述   |
|----------|--------|------|------|
| workid   | String | √    | 实例id |
| trackid  | String | √    | 路径id |
| tenantid | String | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.stopWork(workid,trackid,tenantid);
```
### 结束实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>stopWork</td>
        <td>中文名称</td>
        <td>结束实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean stopWork(String workid,String trackid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| trackid    | String | √    | 路径id  |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.stopWork(workid,trackid,tenantid,identifier);
```
### 批量结束实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>stopWork</td>
        <td>中文名称</td>
        <td>结束实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean stopWork(String workids,String trackids,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型       | 是否必填 | 描述   |
|----------|----------|------|------|
| workids  | String[] | √    | 实例id |
| trackids | String[] | √    | 路径id |
| tenantid | String   | √    | 租户id |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
String[] trackids = {"yyy"};
String result = iwm.stopWork(workids,trackids,tenantid);
```
### 批量结束实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>stopWork</td>
        <td>中文名称</td>
        <td>结束实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean stopWork(String workids,String trackids,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型       | 是否必填 | 描述    |
|------------|----------|------|-------|
| workids    | String[] | √    | 实例id  |
| trackids   | String[] | √    | 路径id  |
| tenantid   | String   | √    | 租户id  |
| identifier | String   | √    | 数据源标识 |

**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
String[] trackids = {"yyy"};
String result = iwm.stopWork(workids,trackids,tenantid);
```
### 获取节点选择参与者类型(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getSelectType</td>
        <td>中文名称</td>
        <td>获取节点选择参与者类型</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于替换办理人时，获取是单选或者多选</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getSelectType(String workid,String trackid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述   |
|----------|--------|------|------|
| workid   | String | √    | 实例id |
| trackid  | String | √    | 路径id |
| tenantid | String | √    | 租户id |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
int result = iwm.getSelectType(workid,trackid,tenantid);
```
### 获取节点选择参与者类型
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getSelectType</td>
        <td>中文名称</td>
        <td>获取节点选择参与者类型</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getSelectType(String workid,String trackid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| trackid    | String | √    | 路径id  |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
int result = iwm.getSelectType(workid,trackid,tenantid,identifier);
```
### 替换处理人(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>replaceAuthor</td>
        <td>中文名称</td>
        <td>替换处理人</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于替换当前节点的处理人</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean replaceAuthor(String workid,String trackid,String userids,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述                  |
|----------|--------|------|---------------------|
| workid   | String | √    | 实例id                |
| trackid  | String | √    | 路径id                |
| userids  | String | √    | 替换的处理人，多个用户中间用“;”分隔 |
| tenantid | String | √    | 租户id                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.replaceAuthor(workid,trackid,userids,tenantid);
```
### 替换处理人
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>replaceAuthor</td>
        <td>中文名称</td>
        <td>替换处理人</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于替换当前节点的处理人</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean replaceAuthor(String workid,String trackid,String userids,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述                  |
|------------|--------|------|---------------------|
| workid     | String | √    | 实例id                |
| trackid    | String | √    | 路径id                |
| userids    | String | √    | 替换的处理人，多个用户中间用“;”分隔 |
| tenantid   | String | √    | 租户id                |
| identifier | String | √    | 数据源标识               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.replaceAuthor(workid,trackid,userids,tenantid,identifier);
```
### 获取节点选择参与者类型
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getSelectType</td>
        <td>中文名称</td>
        <td>获取节点选择参与者类型</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于将当前实例状态改为结束</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getSelectType(String workid,String trackid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述    |
|------------|--------|------|-------|
| workid     | String | √    | 实例id  |
| trackid    | String | √    | 路径id  |
| tenantid   | String | √    | 租户id  |
| identifier | String | √    | 数据源标识 |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
int result = iwm.getSelectType(workid,trackid,tenantid,identifier);
```
### 删除实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>deleteWork</td>
        <td>中文名称</td>
        <td>删除实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于删除实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean deleteWork(String workid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述                  |
|----------|--------|------|---------------------|
| workid   | String | √    | 实例id                |
| tenantid | String | √    | 租户id                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.deleteWork(workid,tenantid);
```
### 删除实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
         <td>deleteWork</td>
        <td>中文名称</td>
        <td>删除实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于删除实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean deleteWork(String workid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述                  |
|------------|--------|------|---------------------|
| workid     | String | √    | 实例id                |
| tenantid   | String | √    | 租户id                |
| identifier | String | √    | 数据源标识               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result =  iwm.deleteWork(workid,tenantid,identifier);
```
### 批量删除实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>deleteWork</td>
        <td>中文名称</td>
        <td>删除实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量删除实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean deleteWork(String workid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型       | 是否必填 | 描述                  |
|----------|----------|------|---------------------|
| workids  | String[] | √    | 实例id                |
| tenantid | String   | √    | 租户id                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
boolean result = iwm.deleteWork(workid,tenantid);
```
### 批量删除实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
         <td>deleteWork</td>
        <td>中文名称</td>
        <td>删除实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量删除实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean deleteWork(String[] workids,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型       | 是否必填 | 描述                  |
|------------|----------|------|---------------------|
| workids    | String[] | √    | 实例id                |
| tenantid   | String   | √    | 租户id                |
| identifier | String   | √    | 数据源标识               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
boolean result = iwm.deleteWork(workids,tenantid,identifier);
```
### 更新实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>updateWork</td>
        <td>中文名称</td>
        <td>更新实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于更新实例数据</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean updateWork(String workid,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型     | 是否必填 | 描述                  |
|----------|--------|------|---------------------|
| workid   | String | √    | 实例id                |
| tenantid | String | √    | 租户id                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result = iwm.updateWork(workid,tenantid);
```
### 更新实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>updateWork</td>
        <td>中文名称</td>
        <td>更新实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于更新实例数据</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">boolean updateWork(String workid,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型     | 是否必填 | 描述                  |
|------------|--------|------|---------------------|
| workid     | String | √    | 实例id                |
| tenantid   | String | √    | 租户id                |
| identifier | String | √    | 数据源标识               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
boolean result =  iwm.updateWork(workid,tenantid,identifier);
```
### 批量更新实例(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>updateWork</td>
        <td>中文名称</td>
        <td>更新实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量更新实例数据</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">Map&lt;String,Boolean&gt; updateWork(String[] workids,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称     | 类型       | 是否必填 | 描述                  |
|----------|----------|------|---------------------|
| workids  | String[] | √    | 实例id                |
| tenantid | String   | √    | 租户id                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();	//流程管理相关方法接口
String[] workids ={"xxx"};
Map<String, Boolean> result = iwm.updateWork(workids,tenantid);
```
### 批量更新实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>updateWork</td>
        <td>中文名称</td>
        <td>更新实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于批量更新实例数据</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">Map&lt;String,Boolean&gt; updateWork(String[] workids,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型       | 是否必填 | 描述                  |
|------------|----------|------|---------------------|
| workids    | String[] | √    | 实例id                |
| tenantid   | String   | √    | 租户id                |
| identifier | String   | √    | 数据源标识               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
String[] workids ={"xxx"};
Map<String, Boolean> result = iwm.updateWork(workids,tenantid,identifier);
```
### 查询用户待办
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getTodoList</td>
        <td>中文名称</td>
        <td>查询用户待办</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的待办</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getTodoList(TodoPara todoPara)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();	
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result = iwm.getTodoList(para);
```
### 查询用户待办数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getTodoCount</td>
        <td>中文名称</td>
        <td>查询用户待办数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的待办数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getTodoCount(TodoPara todoPara)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result =  iwm.getTodoCount(para);
```
### 查询用户已办
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getHasTodoList</td>
        <td>中文名称</td>
        <td>查询用户已办</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的已办</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getHasTodoList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result =  iwm.getHasTodoList(para);
```
### 查询用户已办数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getHasTodoCount</td>
        <td>中文名称</td>
        <td>查询用户已办数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的已办数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getHasTodoCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getHasTodoCount(para);
```
### 查询用户待阅
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getToBeReadList</td>
        <td>中文名称</td>
        <td>查询用户待阅</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的待阅</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getToBeReadList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result =  iwm.getToBeReadList(para);
```
### 查询用户待阅数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getToBeReadCount</td>
        <td>中文名称</td>
        <td>查询用户待阅数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的待阅数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getToBeReadCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getToBeReadCount(para);
```
### 查询用户已阅
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
         <td>getHaveReadList</td>
        <td>中文名称</td>
        <td>查询用户已阅</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的已阅</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getHaveReadList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result = iwm.getHaveReadList(para);
```
### 查询用户已阅数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
       <td>getHaveReadCount</td>
        <td>中文名称</td>
        <td>查询用户已阅数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的已阅数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getHaveReadCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getHaveReadCount(para);
```
### 查询用户认领
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getClaimList</td>
        <td>中文名称</td>
        <td>查询用户认领</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的认领</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getClaimList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result = iwm.getClaimList(para);
```
### 查询用户认领数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getClaimCount</td>
        <td>中文名称</td>
        <td>查询用户认领数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的认领数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getClaimCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getClaimCount(para);
```
### 查询用户可阅文件
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getCReaderList</td>
        <td>中文名称</td>
        <td>查询用户可阅文件</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的可阅文件</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getCReaderList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result = iwm.getCReaderList(para);
```
### 查询用户可阅文件数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getCReaderCount</td>
        <td>中文名称</td>
        <td>查询用户可阅文件数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询指定用户的可阅文件数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getCReaderCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getCReaderCount(para);
```
### 查询用户启动流程实例
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getMyStartList</td>
        <td>中文名称</td>
        <td>查询用户启动流程实例</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询用户启动流程实例</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTodo&gt; getMyStartList(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setFlowid()     | String       |       | 流程id（查询用户启动的流程实例可以传递此参数）                                                         |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setPageNum()    | int          | 分页时必填 | 当前页数                                                                             |
| setPageSize()   | int          | 分页时必填 | 每页显示数目                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |                                                |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager ();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
List<DBTodo> result = iwm.getMyStartList(para);
```
### 查询用户启动流程实例数量
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getMyStartCount</td>
        <td>中文名称</td>
        <td>查询用户可阅文件数量</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询用户启动流程实例数量</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">int getMyStartCount(TodoPara para)</td>
    </tr>
</table>

**参数说明**

| 参数名称            | 类型           | 是否必填  | 描述                                                                               |
|-----------------|--------------|-------|----------------------------------------------------------------------------------|
| setAlluserid()  | String       | √     | 用户id                                                                             |
| setIdentifier() | String       | √     | 数据源标识符                                                                           |
| setTenantid()   | String       | √     | 租户id                                                                             |
| setUserid()     | String       | √     | 当前用户Id                                                                           |
| setWhere()      | String       |       | 额外查询条件<br>如 and title=? or flowname=?                                            |
| setPara()       | List<String> |       | 额外查询条件对应的参数值<br>与问号数量以及顺序保持一致 如 :List.add(titlevalue)<br>List.add(flownamevalue) |
| setOrderby()    | String       |       | 数据排序字段 如：order by title                                                          |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
TodoPara para = new TodoPara();
para.setIdentifier("system");
para.setTenantid("system");
......
int result = iwm.getMyStartCount(para);
```
### 查询允许催办记录(无数据源)
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getTask</td>
        <td>中文名称</td>
        <td>查询允许催办记录</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询允许催办记录</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTask&gt; getTask(String where,List&lt;Object&gt; para,String tenantid)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型           | 是否必填 | 描述                                 |
|------------|--------------|------|------------------------------------|
| where      | String       |      | 查询SQL条件  and flowid=? and userid=? |
| para       | List<Object> |      | 跟where对应的参数值个数以及顺序要与问号匹配           |
| tenantid   | String       | √    | 租户id                               |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
List<DBTask> result = iwm.getTask(where,para,tenantid);
```
### 查询允许催办记录
**服务描述**
<table>
    <tr>
        <td>方法名称</td>
        <td>getTask</td>
        <td>中文名称</td>
        <td>查询允许催办记录</td>
    </tr>
    <tr>
        <td>功能描述</td>
        <td colspan="3">此服务用于查询允许催办记录</td>
    </tr>
    <tr>
        <td colspan="4" align="center">接口信息</td>
    </tr>
    <tr>
        <td>接口类型</td>
        <td>api</td>
        <td>交互频度</td>
        <td>非周期</td>
    </tr>
    <tr>
        <td>接口协议</td>
        <td>直接方法调用</td>
        <td>响应时间</td>
        <td></td>
    </tr>
   <tr>
        <td>备注</td>
        <td colspan="3">List&lt;DBTask&gt; getTask(String where,List&lt;Object&gt; para,String tenantid,String identifier)</td>
    </tr>
</table>

**参数说明**

| 参数名称       | 类型           | 是否必填 | 描述                                 |
|------------|--------------|------|------------------------------------|
| where      | String       |      | 查询SQL条件  and flowid=? and userid=? |
| para       | List<Object> |      | 跟where对应的参数值个数以及顺序要与问号匹配           |
| tenantid   | String       | √    | 租户id                               |
| identifier | String       | √    | 数据源标识                              |
**调用示例**
```
//流程管理相关方法接口
IWorkflowManager iwm = WorkflowFactory.getWorkflowManager();
List<DBTask> result = iwm.getTask(where,para,tenantid,identifier);
```

