
## 附录一——信号发送示例
```
//路径: com.horizon.wf.expand.signal

Signal signal = new Signal();
signal.setSignalPara(信号内容);
signal.setIdentifier(数据源标识符);
SignalListenerUtil.sendSignal(signal);
```
## 附录二——WorkflowOperator流程操作类方法摘要
```
/**
*创建流程实例
*@param workParaBean 创建实例所需参数对象
*@return 实例相关数据
*/
IWorkResult create(WorkParaBean workParaBean)

/**
*关闭实例
*@param workid 实例id
*@param trackid 路径id
* @param userid 用户id
*/
void close(String workid,String trackid,String userid)

/**
*打开流程实例
*@param workParaBean 创建实例所需参数对象
*@return 实例相关数据
*/
IWorkResult open(WorkParaBean workParaBean)

/**
*操作流程实例,通过传入不同的参数完成不同的操作
*@param workParaBean 创建实例所需参数对象
*@return 实例相关数据
*/
IWorkResult operator(WorkParaBean workParaBean)

/**
*获取历史记录
*@param workid 实例id
*@return 实例日志
*/
List getHistory(String workid, String identifier)
```
## 附录三——WorkBean中的result返回值
```
//===============实例初始化返回值 start===========================
	/**
	 * 初始化结果
	 * Init_Success 	= 100
	 * 正常,
	 */
	public static final int  Init_Success 	= 100; 
	/**
	 * Init_ReadMsg 	= 110
	 * 只读状态
	 */
	public static final int  Init_ReadMsg 	= 110;
	/**
	 * Init_Locked 	= 120
	 * 被他人锁定
	 */
	public static final int  Init_Locked 	= 120;
	/**
	 * Init_Cluster =130
	 * 实例正在其他引擎中流转
	 */
	public static final int  Init_Cluster	= 130;
	
	/**
	 * 当前人处于多个活动节点时
	 */
	public static final int Init_SelectNode = 140;
	
	/**
	 * license验证失败
	 */
	public static final int Init_License 	= 200;
	
	/**
	 * Init_NoRole  		= 210
	 * 无权限
	 */
	public static final int  Init_NoRole  	= 210;
	
	/**
	 * Init_Failed=290
	 * 其他失败
	 */
	public static final int  Init_Failed 	= 290; 
	
	
	//其他失败（从WorkBean中的backMsg字段获取错误信息）
	//================实例初始化返回值 end===========================

	//================实例操作返回值 start===========================
	/**
	 * 操作返回类型定义
	 * F_STATUS_Success=0.
	 * 成功
	 */
	public static final int F_STATUS_Success 		= 0;
	/**
	 * F_STATUS_NoFound =1
	 * 无法获取下一节点
	 */
	public static final int F_STATUS_NoFound 		= 1; 
	/**
	 * F_STATUS_SelectNode=2
	 * 提示选择节点
	 */
	public static final int F_STATUS_SelectNode 	= 2;
	/**
	 * F_STATUS_NoAuthor=3
	 * 提示办理人为空
	 */
	public static final int F_STATUS_NoAuthor 		= 3; 
	/**
	 * F_STATUS_SelectAuthor=4
	 * 提示选择人员
	 */
	public static final int F_STATUS_SelectAuthor	= 4; 
	/**
	 * F_STATUS_FlowEnd=5
	 * 流程结束
	 */
	public static final int F_STATUS_FlowEnd 		= 5; 
	/**
	 * F_STATUS_SubFlowNoEnd=6
	 * 子流程未结束
	 */
	public static final int F_STATUS_SubFlowNoEnd	= 6; 
	/**
	 * F_STATUS_FlowPause=7
	 * 流程暂停
	 */
	public static final int F_STATUS_FlowPause    = 7; 
	/**
	 * F_STATUS_FlowErrorEnd=8
	 * 流程异常终止
	 */
	public static final int F_STATUS_FlowErrorEnd	= 8; 	
	/**
	 * F_STATUS_OtherError=9
	 * 其他错误提示
	 */
	public static final int F_STATUS_OtherError  = 9;

    /**
	 * F_STATUS_SecondSubmit=16
	 * 协办人提交
	 */
    public static final int F_STATUS_SecondSubmit  = 16;
    /**
	 * F_STATUS_UnitSubmit=17
	 * 不满足合并节点的离开规则
	 */
    public static final int F_STATUS_UnitSubmit  = 17;
 
    /**
	 * F_STATUS_EntryRule_Error=22
	 * 进入规则调用错误
	 */
     public static final int F_STATUS_EntryRule_Error  = 22;
     /**
	 * F_STATUS_LeaveRule_Error=23
	 * 离开规则调用错误
	 */
     public static final int F_STATUS_LeaveRule_Error  = 23;
     
    /**
	 * F_STATUS_Not_Operator_Nodetype =24
	 *该节点类型不支持相应的操作---会签 加签
	 */    
	public static final int F_STATUS_Not_Operator_Nodetype = 24;
     /**
	 * F_STATUS_StartRule_Error=25
	 * 启用规则调用错误
	 */
     public static final int F_STATUS_StartRule_Error  = 25;
     /**
	 * F_STATUS_Active_Track_Error = 26;
     *节点激活失败
	 */
	public static final int F_STATUS_Active_Track_Error = 26;

```