# 阅知
> 发送阅知、已阅

![流程操作](../../assets/img/rest/flowaction/reader.png)
## 阅知
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e01810a99e66302da",
  "workId": "HZ28858f8103505e01810a99e66302d9",
  "actionData": {
    "operate": "addreader",
    "operateClazz": "com.horizon.wf.action.ActionAddReader",
    "operateFlag": "0",
    "nextNodes": [
      {
        "authors": {
          "Reader": {
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isSelect": "true",
        "nodeId": "Node1",
        "nodeKey": "Node1",
        "selectId": "Node1"
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                               |
|--------------|------|--------------------------------------------------|
| operate      | 是    | 操作标识，限定值addreader                                |
| operateClazz | 是    | 操作具体实现类，限定值com.horizon.wf.action.ActionAddReader |
| operateFlag  | 是    | 转办操作标识固定值0                                       |
| nextNodes    | 是    | 需要选择的节点列表                                        |
nextNodes参数说明：

| 参数       | 是否必须 | 描述                                     |
|----------|------|----------------------------------------|
| authors  | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
| isSelect | 是    | 是否选择了节点，固定值true                        |
| nodeId   | 是    | 需要选择的节点id                              |
| nodeKey  | 是    | 节点主键                                   |
| selectId | 是    | 需要选择的节点id                              |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
  "nextNodeId": "Node1",
  "nextNodes": [
    {
      "authors": {
        "Reader": {
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)",
          "selectType": "checkbox"
        }
      },
      "isSelect": "true",
      "nodeId": "Node1",
      "nodeKey": "Node1",
      "nodeName": "任务1",
      "selectId": "Node1"
    }
  ],
  "operate": "addreader",
  "operateClazz": "com.horizon.wf.action.ActionAddReader",
  "operateFlag": "0",
  "operateMsg": "添加读者成功",
  "operateStatus": "success",
  "reOpen": "true",
  "status": 0,
  "workId": "HZ28858f8103505e01810a99e66302d9"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| nextNodeId    | String | 当前节点id                |
| nextNodes     | List   | 需要选择的节点列表             |
| operate       | String | 阅知操作标识                |
| operateClazz  | String | 阅知操作具体实现类             |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 返回操作信息                |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
*nextNodes参数说明：*

| 参数       | 参数类型   | 描述                                    |
|----------|--------|---------------------------------------|
| authors  | Map    | 下节点办理人map中key为Reader，value为Reader对象参数 |
| isSelect | String | 是否已选择                                 |
| nodeId   | String | 节点id                                  |
| nodeKey  | String | 节点主键                                  |
| nodeName | String | 节点名称                                  |
| selectId | String | 需要选择的节点id                             |
*authors中Reader参数说明：*

| 参数               | 参数类型   | 描述                                     |
|------------------|--------|----------------------------------------|
| selectType       | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |
| selectAuthor     | String | 节点已选择办理人id                             |
| selectAuthorName | String | 节点已选择办理人名称                             |

## 已阅
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8103505e01810aaad77502f8",
  "trackId": "HZ28858d7211dc8b017212e2e9310367",
  "actionData": {
    "operate": "readed",
    "operateClazz": "com.horizon.wf.action.ActionReaded"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                            |
|--------------|------|-----------------------------------------------|
| operate      | 是    | 已阅操作标识，固定值readed                              |
| operateClazz | 是    | 已阅操作类路径，固定值com.horizon.wf.action.ActionReaded |
**返回结果示例：**
```
{
  "alert": "true",
  "operate": "readed",
  "operateClazz": "com.horizon.wf.action.ActionReaded",
  "operateFlag": "1",
  "operateMsg": "已阅标记成功",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e01810aaad77502f8"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| alert         | String | 是否弹出操作成功信息，可忽略        |
| operate       | String | 已阅操作标识                |
| operateClazz  | String | 已阅操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
