 # 补发
> 办理人补发、分支补发

## 补发
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b0181196387730476",
  "trackId": "HZ28858f8113f08b0181196387730477",
  "actionData": {
    "operate": "reissue",
    "operateFlag": 0,
    "operateClazz": "com.horizon.wf.action.ActionReissue",
    "nextNodes": [
      {
        "authors": {
          "Author": {
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20007",
            "selectAuthorName": "用户06"
          }
        },
        "isSelect": "true",
        "nodeKey": "Node2",
        "nodeId": "Node2",
        "selectId": "Node2"
      }
    ]
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                             |
|--------------|------|------------------------------------------------|
| operate      | 是    | 补发操作标识，固定值reissue                              |
| operateFlag  | 是    | 操作标识固定值0                                       |
| operateClazz | 是    | 补发操作类路径，固定值com.horizon.wf.action.ActionReissue |
| nextNodes    | 是    | 需要设置的节点列表                                      |
nextNodes参数说明：

| 参数       | 是否必须 | 描述                                     |
|----------|------|----------------------------------------|
| authors  | 是    | 下一节点办理人对象中key为Author,value值为Author对象参数 |
| nodeKey  | 是    | 节点主键                                   |
| nodeId   | 是    | 需要选择的节点id                              |
| selectId | 是    | 需要选择的节点id                              |
authors中Author对象参数说明：

| 参数               | 是否必须 | 描述         |
|------------------|------|------------|
| selectAuthor     | 是    | 节点已选择办理人id |
| selectAuthorName | 是    | 节点已选择办理人名称 |
**返回结果示例：**
```
{
  "nextNodeId": "Node2",
  "nextNodes": [
    {
      "authors": {
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "true",
          "isUser": "false",
          "selectType": "checkbox"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "isShowTabs": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node2",
      "nodeKey": "Node2",
      "nodeName": "任务2",
      "nodeStatus": "0",
      "selectId": "Node2",
      "selectName": "补发(任务2)"
    }
  ],
  "operate": "reissue",
  "operateClazz": "com.horizon.wf.action.ActionReissue",
  "operateFlag": "0",
  "operateMsg": "补发办理人成功",
  "status": 0,
  "workId": "HZ28858f8113f08b0181196387730476"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                    |
|--------------|--------|-----------------------|
| nextNodeId   | String | 当前节点id                |
| nextNodes    | List   | 需要选择的节点列表             |
| operate      | String | 补发操作标识                |
| operateClazz | String | 补发操作类路径               |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg   | String | 返回操作信息                |
| status       | int    | 流程操作状态码               |
| workId       | String | 流程实例id                |
*nextNodes参数说明：*

| 参数         | 参数类型   | 描述                                                             |
|------------|--------|----------------------------------------------------------------|
| authors    | Map    | 下节点办理人map中key为Author，value为Author对象参数                          |
| isDone     | String | 是否已经走过                                                         |
| isSelect   | String | 是否已选择                                                          |
| isShowTabs | String | 是否显示办理人页签，主要用于运行页面办理人显示，不参与业务处理                                |
| memo       | String | 备注信息                                                           |
| nodeGroup  | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                |
| nodeId     | String | 节点id                                                           |
| nodeKey    | String | 节点主键                                                           |
| nodeName   | String | 节点名称                                                           |
| nodeStatus | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点 |
| selectId   | String | 需要选择的节点id                                                      |
| selectName | String | 需要选择的节点名称                                                      |
*authors中Author参数说明：*

| 参数            | 参数类型   | 描述                                     |
|---------------|--------|----------------------------------------|
| authorFlowVar | String | 流程变量                                   |
| authorId      | String | 办理人id固定值Author                         |
| authorName    | String | 办理人名称：主办                               |
| freeArea      | String | 自由选择时的范围                               |
| isDefUser     | String | 流程定义列表中选择                              |
| isFree        | String | 是否自由选择                                 |
| isSelect      | String | 是否允许选择办理人                              |
| isUser        | String | 是否只允许选择人员                              |
| selectType    | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选  |

## 分支补发
> 用户多分支提交时，补充其他分支节点办理人
![流程操作](../../assets/img/rest/flowaction/track.png)

### 分支补发-获取分支节点
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811d39e32f070e",
  "trackId": "HZ28858f8113f08b01811d39e32f070f",
  "actionData": {
    "operate": "reissuerouter",
    "operateClazz": "com.horizon.wf.action.ActionReissueRouter"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                   |
|--------------|------|------------------------------------------------------|
| operate      | 是    | 补发操作标识，固定值reissuerouter                              |
| operateClazz | 是    | 补发操作类路径，固定值com.horizon.wf.action.ActionReissueRouter |
**返回结果示例：**
```
{
  "nextNodeId": "",
  "nextNodes": [
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node3",
      "nodeKey": "Line3",
      "nodeName": "任务3",
      "nodeStatus": "0",
      "selectId": "Line3~Node3",
      "selectName": "路由3(任务3)",
      "timeLimit": "0",
      "timeLimitType": "1"
    },
    {
      "authors": {},
      "isDone": "false",
      "isSelect": "false",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node4",
      "nodeKey": "Line4",
      "nodeName": "任务4",
      "nodeStatus": "0",
      "selectId": "Line4~Node4",
      "selectName": "路由4(任务4)",
      "timeLimit": "0",
      "timeLimitType": "1"
    }
  ],
  "operate": "reissuerouter",
  "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
  "operateFlag": "1",
  "operateMsg": "请选择补发的分支节点",
  "status": 2,
  "workId": "HZ28858f8113f08b01811d39e32f070e"
}
```
**结果参数说明:**

| 参数           | 参数类型   | 描述                    |
|--------------|--------|-----------------------|
| nextNodeId   | String | 下一节点id                |
| nextNodes    | List   | 需要选择的节点列表             |
| operate      | String | 补发操作标识                |
| operateClazz | String | 补发操作类路径               |
| operateFlag  | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg   | String | 返回操作信息                |
| workId       | String | 流程实例id                |
| status       | int    | 流程操作状态码               |
*nextNodes参数说明：*

| 参数            | 参数类型   | 描述                                                             |
|---------------|--------|----------------------------------------------------------------|
| authors       | Map    | 下节点办理人map中key为Author，value为Author对象参数                          |
| isDone        | String | 是否已经走过                                                         |
| isSelect      | String | 是否已选择                                                          |
| memo          | String | 备注信息                                                           |
| nodeGroup     | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                |
| nodeId        | String | 节点id                                                           |
| nodeKey       | String | 节点主键                                                           |
| nodeName      | String | 节点名称                                                           |
| nodeStatus    | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点 |
| selectId      | String | 需要选择的节点id                                                      |
| selectName    | String | 需要选择的节点名称                                                      |
| timeLimit     | String | 节点办理时限                                                         |
| timeLimitType | String | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                   |

### 分支补发-设置分支节点办理人
> 用户多分支提交时，补充其他分支节点办理人

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "HZ28858f8113f08b01811de1b6710751",
  "trackId": "HZ28858f8113f08b01811de1b6710752",
  "actionData": {
    "authorKey": "Author",
    "nextNodeId": "",
    "nextNodes": [
      {
        "authors": {
          "SecondAuthor": {
            "authorFlowVar": "",
            "authorId": "SecondAuthor",
            "authorName": "协办",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户02(测试部门0)"
          },
          "Reader": {
            "authorFlowVar": "",
            "authorId": "Reader",
            "authorName": "读者",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20004/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户03(测试部门0)"
          },
          "Author": {
            "authorFlowVar": "",
            "authorId": "Author",
            "authorName": "主办",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isDone": "false",
        "isSelect": "true",
        "memo": "",
        "nodeGroup": "",
        "nodeId": "Node3",
        "nodeKey": "Line3",
        "nodeName": "任务3",
        "nodeStatus": "4",
        "selectId": "Line3~Node3",
        "selectName": "路由3(任务3)",
        "timeLimit": "1",
        "timeLimitType": "0"
      },
      {
        "authors": {
          "SecondAuthor": {
            "authorFlowVar": "",
            "authorId": "SecondAuthor",
            "authorName": "协办",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户02(测试部门0)"
          },
          "Reader": {
            "authorFlowVar": "",
            "authorId": "Reader",
            "authorName": "读者",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "checkbox",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20004/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户03(测试部门0)"
          },
          "Author": {
            "authorFlowVar": "",
            "authorId": "Author",
            "authorName": "主办",
            "freeArea": "",
            "isDefUser": "false",
            "isFree": "true",
            "isSelect": "true",
            "isUser": "false",
            "selectType": "radio",
            "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
            "selectAuthorName": "用户01(测试部门0)"
          }
        },
        "isDone": "false",
        "isSelect": "true",
        "memo": "",
        "nodeGroup": "",
        "nodeId": "Node4",
        "nodeKey": "Line4",
        "nodeName": "任务4",
        "nodeStatus": "4",
        "selectId": "Line4~Node4",
        "selectName": "路由4(任务4)",
        "timeLimit": "1",
        "timeLimitType": "0"
      }
    ],
    "nodeId": "Node2",
    "nodeName": "任务2",
    "operate": "reissuerouter",
    "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
    "operateFlag": 0
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程实例路径id      |
| actionData  | 是    | 流程操作json数据    |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                                 |
|--------------|------|----------------------------------------------------|
| authorKey    | 是    | 参与者类型id                                            |
| nextNodeId   | 是    | 下一节点id                                             |
| nextNodes    | 是    | 需要设置的分支节点列表                                        |
| nodeId       | 是    | 当前节点id                                             |
| nodeName     | 是    | 当前节点name                                           |
| operate      | 是    | 分支补发操作标识，固定值reissuerouter                          |
| operateClazz | 是    | 分支补发操作类路径com.horizon.wf.action.ActionReissueRouter |
| operateFlag  | 是    | 分支操作标识，固定值0                                        |
nextNodes参数说明：

| 参数            | 是否必须 | 描述                                                                                 |
|---------------|------|------------------------------------------------------------------------------------|
| authors       | 是    | 下一节点办理人对象中key为SecondAuthor<br>、Reader和Author,value值为Author/SecondAuthor/Reader对象参数 |
| isDone        | 否    | 是否已经走过                                                                             |
| isSelect      | 是    | 是否已选择                                                                              |
| memo          | 否    | 备注信息，rest提交时可忽略                                                                    |
| nodeGroup     | 否    | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id，rest提交时可忽略                                         |
| nodeId        | 是    | 节点id                                                                               |
| nodeKey       | 是    | 节点主键                                                                               |
| nodeName      | 否    | 是节点名称                                                                              |
| nodeStatus    | 否    | 节点状态，rest提交时可忽略                                                                    |
| selectId      | 是    | 需要选择的节点id                                                                          |
| selectName    | 否    | 需要选择的节点名称                                                                          |
| isShowTabs    | 否    | 是否显示办理人页签，<br>主要用于运行页面办理人显示，<br>不参与业务处理rest提交时可忽略                                  |
| timeLimit     | 否    | 节点办理时限，自然数                                                                         |
| timeLimitType | 否    | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                                       |
authors中Author/SecondAuthor/Reader对象参数说明：

| 参数               | 是否必须 | 描述                                                       |
|------------------|------|----------------------------------------------------------|
| authorFlowVar    | 否    | 流程变量                                                     |
| authorId         | 否    | 办理人类型id，限定值<br>Author：主办<br>SecondAuthor：协办<br>Reader：读者 |
| authorName       | 否    | 办理人类型名称/主办/协办/读者                                         |
| freeArea         | 否    | 自由选择时的范围                                                 |
| isDefUser        | 否    | 流程定义列表中选择                                                |
| isFree           | 否    | 是否自由选择                                                   |
| isSelect         | 否    | 是否允许选择办理人                                                |
| isUser           | 否    | 是否只允许选择人员                                                |
| selectType       | 否    | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选                    |
| selectAuthor     | 是    | 节点已选择办理人id<br>没有协办/读者时，参数可以不填写                           |
| selectAuthorName | 是    | 节点已选择办理人名称<br>没有协办/读者时，参数可以不填写                           |
| authorName       | 否    | 办理人名称，限定值：主办，协办，读者                                       |

**返回结果示例：**
```
{
  "nextNodeId": "Line3~Node3&Line4~Node4",
  "nextNodes": [
    {
      "authors": {
        "SecondAuthor": {
          "authorFlowVar": "",
          "authorId": "SecondAuthor",
          "authorName": "协办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户02(测试部门0)",
          "selectType": "checkbox"
        },
        "Reader": {
          "authorFlowVar": "",
          "authorId": "Reader",
          "authorName": "读者",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20004",
          "selectAuthorName": "用户03",
          "selectType": "checkbox"
        },
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node3",
      "nodeKey": "Line3",
      "nodeName": "任务3",
      "nodeStatus": "0",
      "selectId": "Line3~Node3",
      "selectName": "路由3(任务3)",
      "timeLimit": "1",
      "timeLimitType": "0"
    },
    {
      "authors": {
        "SecondAuthor": {
          "authorFlowVar": "",
          "authorId": "SecondAuthor",
          "authorName": "协办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20003/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户02(测试部门0)",
          "selectType": "checkbox"
        },
        "Reader": {
          "authorFlowVar": "",
          "authorId": "Reader",
          "authorName": "读者",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20004",
          "selectAuthorName": "用户03",
          "selectType": "checkbox"
        },
        "Author": {
          "authorFlowVar": "",
          "authorId": "Author",
          "authorName": "主办",
          "freeArea": "",
          "isDefUser": "false",
          "isFree": "true",
          "isSelect": "false",
          "isUser": "false",
          "selectAuthor": "U_HZ28821856ef63420156ef6342a20002/D_HZ28821856ef63420156ef6342a20001",
          "selectAuthorName": "用户01(测试部门0)",
          "selectType": "radio"
        }
      },
      "isDone": "false",
      "isSelect": "true",
      "memo": "",
      "nodeGroup": "",
      "nodeId": "Node4",
      "nodeKey": "Line4",
      "nodeName": "任务4",
      "nodeStatus": "0",
      "selectId": "Line4~Node4",
      "selectName": "路由4(任务4)",
      "timeLimit": "1",
      "timeLimitType": "0"
    }
  ],
  "operate": "reissuerouter",
  "operateClazz": "com.horizon.wf.action.ActionReissueRouter",
  "operateFlag": "0",
  "operateMsg": "补发分支成功",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "trackId": "HZ28858f8113f08b01811de5c2290787;HZ28858f8113f08b01811de5c2290788",
  "workId": "HZ28858f8113f08b01811de1b6710751"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| nextNodeId    | String | 下一节点id                |
| nextNodes     | List   | 需要选择的节点列表             |
| operate       | String | 补发操作标识                |
| operateClazz  | String | 补发操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 返回操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
| trackId       | String | 流程实例路径id              |
*nextNodes参数说明：*

| 参数            | 参数类型   | 描述                                                                        |
|---------------|--------|---------------------------------------------------------------------------|
| authors       | Map    | 下节点办理人map中key为Author/SecondAuthor/Reader/，value为/SecondAuthor/Reader/对象参数 |
| isDone        | String | 是否已经走过                                                                    |
| isSelect      | String | 是否已选择                                                                     |
| memo          | String | 备注信息                                                                      |
| nodeGroup     | String | 节点分组，单节点时无值，当前节点有分支节点时，值为上一节点id                                           |
| nodeId        | String | 节点id                                                                      |
| nodeKey       | String | 节点主键                                                                      |
| nodeName      | String | 节点名称                                                                      |
| nodeStatus    | String | 节点状态，限定值<br>0.成功<br>1.选择办理人<br>2.选择节点<br>3.未找到办理人<br>4.未找到下一节点            |
| selectId      | String | 需要选择的节点id                                                                 |
| selectName    | String | 需要选择的节点名称                                                                 |
| timeLimit     | String | 节点办理时限                                                                    |
| timeLimitType | String | 办理时限类型，限定值<br>0：自然日<br>1：工作日                                              |
authors中Author/SecondAuthor/Reader对象参数说明：

| 参数               | 参数类型   | 描述                                                       |
|------------------|--------|----------------------------------------------------------|
| authorFlowVar    | String | 流程变量                                                     |
| authorId         | String | 办理人类型id，限定值<br>Author：主办<br>SecondAuthor：协办<br>Reader：读者 |
| authorName       | String | 办理人类型名称/主办/协办/读者                                         |
| freeArea         | String | 自由选择时的范围                                                 |
| isDefUser        | String | 流程定义列表中选择                                                |
| isFree           | String | 是否自由选择                                                   |
| isSelect         | String | 是否允许选择办理人                                                |
| isUser           | String | 是否只允许选择人员                                                |
| selectAuthor     | String | 节点已选择办理人id<br>没有协办/读者时，参数可以不填写                           |
| selectAuthorName | String | 节点已选择办理人名称<br>没有协办/读者时，参数可以不填写                           |
| selectType       | String | 人员选择类型，限定值<br>radio：单选<br>checkbox：多选                    |
