# 催办、撤办
> 发起催办、撤销办理

## 催办
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d8a1dc0110",
  "workId": "HZ28858f8103505e018104d8a1dc010f",
  "actionData": {
    "operate": "urge",
    "operateClazz": "com.horizon.wf.action.ActionReMsg"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                       |
|--------------|------|------------------------------------------|
| operate      | 是    | 催办操作标识，固定值urge                           |
| operateClazz | 是    | 催办操作类路径com.horizon.wf.action.ActionReMsg |
**返回结果示例：**
```
{
  "alert": "true",
  "operate": "urge",
  "operateClazz": "com.horizon.wf.action.ActionReMsg",
  "operateFlag": "1",
  "operateMsg": "催办成功",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018104d8a1dc010f"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| alert         | String | 是否弹出操作成功信息，可忽略        |
| operate       | String | 操作标识，固定值              |
| operateClazz  | String | 催办操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常提交 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |

## 撤办
> 当实例进行撤办后，再次调用该方法，表示为恢复流程

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/action{suffix} <br>
**post数据说明：**
```
{
  "accessToken": "",
  "trackId": "HZ28858f8103505e018104d8a1dc0110",
  "workId": "HZ28858f8103505e018104d8a1dc010f",
  "actionData": {
    "operate": "cancel",
    "operateClazz": "com.horizon.wf.action.ActionCancel"
  }
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程路径id        |
| actionData  | 是    | 其他提交数据        |
actionData 数据参数:

| 参数           | 是否必须 | 描述                                         |
|--------------|------|--------------------------------------------|
| operate      | 是    | 撤办操作标识，固定值cacel                            |
| operateClazz | 是    | 撤办操作类路径com.horizon.wf.action.ActionCancel  |
**返回结果示例：**
```
{
  "alert": "true",
  "operate": "cancel",
  "operateClazz": "com.horizon.wf.action.ActionCancel",
  "operateFlag": "1",
  "operateMsg": "撤办流程成功",
  "operateStatus": "success",
  "reOpen": "false",
  "status": 0,
  "workId": "HZ28858f8103505e018104d8a1dc010f"
}
```
**结果参数说明:**

| 参数            | 参数类型   | 描述                    |
|---------------|--------|-----------------------|
| alert         | String | 是否弹出操作成功信息，可忽略        |
| operate       | String | 撤办操作操作标识              |
| operateClazz  | String | 撤办操作类路径               |
| operateFlag   | String | 操作标记 -1：显示关闭，0、1：正常操作 |
| operateMsg    | String | 流程操作返回信息              |
| operateStatus | String | 流程操作结果                |
| reOpen        | String | 是否重新打开，可忽略            |
| status        | int    | 流程操作状态码               |
| workId        | String | 流程实例id                |
