# 流程操作日志

## 流程实例流转日志
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/log/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": "",
  "type": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                 |
|-------------|------|----------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                      |
| page        | 否    | 页码，如果为空表示查询全部数据                                    |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                              |
| sort        | 否    | 排序，默认为正序。字段前如果加上减号，如sort=-flowName则为按照flowName倒序排列 |
| search      | 否    | 简单查询流程标题、流程名称和节点名称字段,默认为空时查询所有数据                   |
| type        | 否    | 流程类型,type为空或没有值时，查询的是未分类的流程实例流转记录                  |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "action": "autofirst",
      "actionName": "启动流程",
      "actionTime": "2020-06-16 10:01:49",
      "doTime": "0 天 0 时 0 分",
      "doTimeMin": "0",
      "flowId": "www",
      "flowName": "新流程www",
      "id": "HZ28811c72badc560172badc73ae0008",
      "isOver": "0",
      "limitTime": "",
      "nextNodeIds": "Node1;",
      "nodeId": "Start",
      "nodeName": "开始",
      "sxcomments": "",
      "title": "新流程www",
      "trackId": "HZ28811c72badc560172badc725a0006",
      "type": "",
      "userId": "admin",
      "userName": "管理员",
      "workId": "HZ28811c72badc560172badc72580005"
    }
  ],
  "message": "",
  "recordsTotal": "9",
  "success": true
}
```
**结果参数说明:**

| 参数          | 参数类型   | 描述                    |
|-------------|--------|-----------------------|
| action      | String | 操作标识                  |
| actionName  | String | 操作名称                  |
| actionTime  | String | 操作时间                  |
| doTime      | String | 从接收到操作的历时（中文）         |
| doTimeMin   | String | 历时（分钟）                |
| flowId      | String | 流程id                  |
| flowName    | String | 流程名称                  |
| id          | String | 操作记录id                |
| isOver      | String | 执行操作时是否已超期<br> 1是 0 否 |
| nodeId      | String | 节点id                  |
| nodeName    | String | 节点名称                  |
| limitTime   | String | 节点办理时限                |
| sxcomments  | String | 手写意见                  |
| title       | String | 标题                    |
| trackId     | String | 流程实例路径id              |
| type        | String | 流程类型                  |
| nextNodeIds | String | 下一节点id                |
| userId      | String | 用户id                  |
| userName    | String | 用户名称                  |
| workId      | String | 流程实例实例id              |

## 流程定义更新日志
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/def/log/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "flowName",
  "search": "",
  "type": ""
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                 |
|-------------|------|----------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                      |
| page        | 否    | 页码，如果为空表示查询全部数据                                    |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                              |
| sort        | 否    | 排序，默认为正序。字段前如果加上减号，如sort=-flowName则为按照flowName倒序排列 |
| search      | 否    | 简单查询流程名称、操作名称和操作人,默认为空时查询所有数据                      |
| type        | 否    | 流程类型,type为空或没有值时，查询的是未分类的流程实例流转记录                  |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "actionName": "修改流程,版本不变",
      "actionTime": "2022-05-11 14:32:06",
      "flowId": "test",
      "flowName": "新流程test",
      "id": "HZ28858f80b0f42d0180b1d14f1d0989",
      "type": "未分类",
      "userId": "admin",
      "userName": "管理员",
      "version": 1,
      "workId": ""
    }
  ],
  "message": "",
  "recordsTotal": "11",
  "success": true
}
```
**结果参数说明:**

| 参数         | 参数类型   | 描述                  |
|------------|--------|---------------------|
| actionTime | String | 操作时间                |
| actionName | String | 操作内容                |
| flowId     | String | 流程id                |
| flowName   | String | 流程名称                |
| id         | String | 操作记录id              |
| type       | String | 流程类型                |
| userId     | String | 操作用户id              |
| userName   | String | 操作用户名称              |
| version    | String | 操作版本                |
| workId     | String | 流程实例id，修改实例建模时才会记录值 |

