# 获取操作记录{docsify-ignore-all}

接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/flow/support/history.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "workId": "",
  "skipFields": "limittime;dotimemin"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                                                 |
|-------------|------|--------------------------------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                                      |
| workId      | 是    | 流程实例id                                                             |
| skipFields  | 否    | 过滤不需要的返回值格式（limittime;dotimemin）<br>这样就可以过滤掉这两个字段<br>，如果为空，则返回全部字段 |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "action": "autofirst",
      "actionname": "启动流程",
      "actiontime": "2022-05-19 10:11:49",
      "comments": "",
      "dotime": "0 天 0 时 0 分",
      "dotimemin": "0",
      "flowid": "test",
      "flowname": "新流程test",
      "id": "HZ28858f80da101c0180da15e4370060",
      "isover": "0",
      "limittime": "",
      "memo": "提交到节点[任务1]处理人:管理员(慧正通软)",
      "nextnodeids": "Node1;",
      "nodeid": "Start",
      "nodename": "开始",
      "sxcomments": "",
      "title": "新流程test",
      "trackid": "HZ28858f80da101c0180da15e433005e",
      "userid": "admin",
      "username": "管理员",
      "workid": "HZ28858f80da101c0180da15e433005d"
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**结果参数说明:**

| 参数          | 参数类型   | 描述                     |
|-------------|--------|------------------------|
| action      | String | 操作标识                   |
| actionname  | String | 操作名称                   |
| actiontime  | String | 操作时间                   |
| comments    | String | 意见                     |
| dotime      | String | 从接收到操作的历时（中文）          |
| dotimemin   | String | 历时（分钟）                 |
| flowid      | String | 流程id                   |
| flowname    | String | 流程名称                   |
| id          | String | 记录数据id                 |
| isover      | String | 执行操作时是否已超期<br>1：是 0： 否 |
| limittime   | String | 节点办理时限                 |
| memo        | String | 执行操作后提交目标提示信息记录        |
| nextnodeids | String | 下一节点id，流程操作不涉及下一节点时没有值 |
| nodeid      | String | 流程操作时所在的节点id           |
| nodename    | String | 节点名称                   |
| sxcomments  | String | 手写意见                   |
| title       | String | 标题                     |
| trackid     | String | 流转路径id                 |
| userid      | String | 用户id                   |
| username    | String | 用户名称                   |
| workid      | String | 实例id                   |
