# 流程实例

## 查询流程实例列表
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/page.wf <br>
**post数据说明：**
```
{
  "accessToken": "",
  "page": "1",
  "limit": "10",
  "sort": "created",
  "search":"测试"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                                           |
|-------------|------|----------------------------------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识                                |
| page        | 否    | 页码，如果为空表示查询全部数据                              |
| limit       | 否    | 每页显示的数据条数，如果为空默认查询10条                        |
| sort        | 否    | 非必须，字段前如果加上减号。如sort=- created则为按照created倒序排列 |
| search      | 否    | 非必须，搜索项有节点id、流程id、分类、search（标题和流程名称模糊搜索）     |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    {
      "created": "2022-05-18 15:39:05",
      "creator": "admin",
      "flowId": "testhuiqian",
      "flowName": "新流程会签",
      "id": "HZ28858f80d61b260180d61b26ee0001",
      "nodeId": "Node2",
      "nodeName": "任务2",
      "status": "正常",
      "title": "新流程会签",
      "trackId": "HZ28858f80d61b260180d61b26f00002",
      "typeName": "",
      "ver": "4",
      "version": "2"
    }
  ],
  "message": "",
  "recordsTotal": "3",
  "success": true
}
```
**结果参数说明:**

| 参数       | 参数类型   | 描述       |
|----------|--------|----------|
| created  | String | 发起时间     |
| creator  | String | 发起人      |
| flowId   | String | 流程模板id   |
| flowName | String | 流程名字     |
| id       | String | 流程实例id   |
| nodeId   | String | 实例节点id   |
| nodeName | String | 实例节点名称的  |
| typeName | String | 流程分类     |
| status   | String | 实例状态     |
| title    | String | 流程实例标题   |
| trackId  | String | 流程实例路径id |
| ver      | String | 流程模板发布版本 |
| version  | String | 实例流转版本   |

## 流程实例可恢复的版本
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/recover/vernum.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": " "
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
**返回结果示例：**
```
{
  "code": 0,
  "data": [
    1
  ],
  "message": "",
  "success": true
}
```
**结果参数说明:**

| 参数   | 参数类型 | 描述    |
|------|------|-------|
| data | List | 版本号数组 |

## 恢复流程实例到指定的版本
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/recover/version.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": " ",
  "selectVer":" "
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| selectVer   | 是    | 流程实例要恢复版本     |
**返回结果示例：**
```
{
  "message": "恢复成功",
  "code": 1,
  "success": true
}
```

## 终止流程实例
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/state/end.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": "HZ28811c72024d8d0172024da7b60007",
  "trackId":"HZ28811c72024d8d0172024da7b40006"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程实例路径id      |
**返回结果示例：**
```
{
  "code": 0,
  "message": "实例停止成功",
  "success": true
}
```

## 替换流程办理人
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/replace/author.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": "HZ28811c72024d8d0172024da7b60007",
  "trackId":"HZ28811c72024d8d0172024da7b40006",
  "author":"admin"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
| trackId     | 是    | 流程实例路径id      |
| author      | 是    | 流程待办人id       |
**返回结果示例：**
```
{
  "code": 0,
  "message": "实例替换办理人成功",
  "success": true
}
```

## 更新流程实例
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/update.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": "HZ28811c72024d8d0172024da7b60007"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述            |
|-------------|------|---------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识 |
| workId      | 是    | 流程实例id        |
**返回结果示例：**
```
{
  "code": 0,
  "message": "实例更新成功",
  "success": true
}
```

## 删除流程实例
接口请求调用说明 <br>
http请求方式: POST <br>
请求地址: http://127.0.0.1:8080/demo/horizon/workflow/rest/monitor/instance/delete.wf <br>
**post数据说明：**
```
{
  "accessToken": " ",
  "workId": "HZ28811c72024d8d0172024da7b60007"
}
```
请求参数说明:

| 参数          | 是否必须 | 描述                  |
|-------------|------|---------------------|
| accessToken | 是    | 调用接口凭证，唯一用户标识       |
| workId      | 是    | 流程实例id，多个流程实例用分号;隔开 |
**返回结果示例：**
```
{
  "message": "实例删除失败",
  "code": 1,
  "success": true,
  "data": [
    "HZ28858f80d529f40180d55429610064 "
  ]
}
```
**结果参数说明:**

| 参数   | 参数类型 | 描述                  |
|------|------|---------------------|
| data | List | 删除失败时，返回删除失败的实例id数组 |
